;*********** ணࠬ RA4NAL-2003.12 (Rescue) ***********
;
; ⠭
$MOD51
NBaud     EQU 8      ; - ⠭ ᪮
STEC      EQU 5FH    ; 砫 ⥪-1
BufCom    EQU 30H    ; 砫  
BufLng    EQU 15H    ;   
StartChar EQU ':'    ; Line start character for hex file.
Skip      EQU 13     ; Value for "Skip" state.
SOH       EQU 01H
EOT       EQU 04H
ACK       EQU 06H
NAK       EQU 15H
CAN       EQU 18H
;
MaxTry27  EQU 50     ; - ⮪  27...
MaxTr27C  EQU 20     ; - ⮪  27C...
;
; 58055
PortA     EQU   00
PortB     EQU   01
PortC     EQU   02
RUS       EQU   03
PABCIN    EQU   9BH   ; PA, PB, PC - IN
PABCOUT   EQU   80H   ; PA, PB, PC - OUT
;
; 뢮  P3 BE31
; P3.5=1 饭  
; P3.5=0 饭  58055
; P3.4=1 Vcc=5v
; P3.4=0 Vcc=6,5v
; P3.3=0 P3.2=0 Vpp=Vcc
; P3.3=0 P3.2=1 Vpp=25v
; P3.3=1 P3.2=0 Vpp=0v
OZU      EQU   0E3H  ; 1110.0011 饭  
BB55     EQU   0C3H  ; 1100.0011 饭  580BB55
Vc5Vp5   EQU   10H   ; 0001.0000 Vpp=Vcc=5v
Vc6Vp6   EQU   00    ; 0000.0000 Vpp=Vcc=6,5v
Vc5Vp0   EQU   18H   ; 0001.1000 Vpp=0 Vcc=5v
Vc6Vp0   EQU   08H   ; 0000.1000 Vpp=0 Vcc=6,5v
Vc5Vp25  EQU   14H   ; 0001.0100 Vpp=25v Vcc=5v
Vc6Vp25  EQU   04H   ; 0000.0100 Vpp=25v Vcc=6,5v

SoftProtect EQU 05   ;  EEPROM,  .   
Tip28256    EQU 06   ;  28C256
TipW27C512  EQU 01   ;  W27C512

; ᯮ㥬 祩
TipPZU    EQU  5FH    ;!!!  .  ⨯ 
ClasPZU   EQU  5EH    ;!!!  .  ᮬ 
CharL     EQU  5DH    ;!Holds low byte of frame timer result.
CharH     EQU  5CH    ;!Holds high byte of frame timer result.
BaudRate  EQU  5BH    ;!! Holds final baud rate determination.
CharL1    EQU  5BH    ;!! .  2- ࠬ
CharH1    EQU  5AH    ;!  .  2- ࠬ
;
FilChkLo  EQU  59H    ;!! File checksum low byte.
CharL2    EQU  59H    ;!! .  3- ࠬ
FilChkHi  EQU  58H    ;!! File checksum high byte.
CharH2    EQU  58H    ;!! .  3- ࠬ
LaSave    EQU  57H    ;!   from the last data line.
HaSave    EQU  56H    ;! Saves the high and low address bytes
ChkSum    EQU  55H    ;! Calculated checksum received.
RecType   EQU  54H    ;! Line record type for this line.
LowAddr   EQU  53H    ;   current data line.
HighAddr  EQU  52H    ; High and low address bytes from the
ByteCount EQU  51H    ; Data byte count from current line.
DataByte  EQU  50H    ; Last data byte received.
State     EQU  4FH    ; Identifies the state in process.
Lh        EQU  4EH    ; Last character received.
;
BlkN      EQU  4DH    ;!  ਭ⮣  । 
TmpPrn    EQU  4CH    ; ᯮ.  PrnEVer

; 30H...44H -  

;   祩 2FH (ਥ  ᪮஢ HEX 䠩)
Flags       EQU  2FH; State condition flags.
;
HexFlag     EQU  78H; =0  HEX , =1  OK
EndFlag     EQU  79H; End record found.
DoneFlag    EQU  7AH; Processing done (end record or some kind of error).
DatSkipFlag EQU  7BH; Any data found should be ignored.
;
;   祩 2EH (ਥ  ᪮஢ HEX 䠩)
EFlags      EQU  2EH; Exception flags.
;
ErrFlag1    EQU  70H; Non-hex character embedded in data.
ErrFlag2    EQU  71H; Bad record type.
ErrFlag3    EQU  72H; Bad line checksum.
ErrFlag4    EQU  73H; No data found.
ErrFlag5    EQU  74H; Incremented address overflow.
ErrFlag6    EQU  75H; Data storage verify error.
;
;   祩 2DH ( )
;
MyFlags     EQU  2DH
BitWin      EQU  68H; =0-DOS, =1-WIN/KOI-8
BitKOI      EQU  69H; =0-DOS/WIN, =1- KOI-8
ProtectON   EQU  6DH ;  EEPROM  ⮩
ProtectOF   EQU  6EH ;   ⨥ 
;
;   祩 2CH (ਡ )
;
AtribPZU    EQU  2CH
;
;   ⨯:
NotFlash    EQU  62H; =1  FLASH PIC, =0 FLASH
;
;  EPROM, EEPROM:
MASKA14     EQU  64H; =1  ⥭ A14=1
MASKA11     EQU  65H; =1  ⥭ A11=1
Vpp5        EQU  66H; =1  ⥭ Vpp=5v, =0 - Vpp=0v
Vcc6        EQU  67H; =1   Vcc=6,5v, =0 - Vcc=5v
;
MaskaOZU    EQU  0FFH   ; ᪠  ⪥  ( 07FH,  0FFH)

            ORG  0000H
;
Start:   NOP
         AJMP  BEGIN
         LJMP  8003H      ; INT0
         DB    0FFH,0FFH,0FFH,0FFH,0FFH
         LJMP  800BH      ; TF0
         DB    0FFH,0FFH,0FFH,0FFH,0FFH
         LJMP  8013H      ; INT1
         DB    0FFH,0FFH,0FFH,0FFH,0FFH
         LJMP  801BH      ; TF1
         DB    0FFH,0FFH,0FFH,0FFH,0FFH
         LJMP  8023H      ; UART
         DW    0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH

;**************** 砫 ணࠬ *****************
;        ORG   0030H

BEGIN:   MOV   SP,#STEC
         ACALL PzuOFF          ; 몫. 
         MOV   PCON,#80H       ; SMOD=1
         CLR   A
         MOV   PSW,A
         MOV   IE,A
         MOV   IP,A
         MOV   TipPZU,A;     ⨯  ࠭
         MOV   ClasPZU,A;      ࠭
         MOV   MyFlags,A;     䫠
         AJMP  AutoBaud                           ;0046H
;
; Compare table holds timer values for the transition points of the accepted
; baud rates. Entries are LSB, MSB. These values are for 11,059 MHz.
;               11059000 (f)    7 (bits-to-recognize)
; Table entry = ----------- * ----  +  0C000H (. . TC0)
;                 Baud         12
CmpTable:
          DB    3CH,0C0H        ;0 - out of range, value too low.
          DB    70H,0C0H        ;1 - 57600 baud.
          DB   0E0H,0C0H        ;2 - 28800 baud.
          DB    50H,0C1H        ;3 - 19200 baud.
          DB   0C0H,0C1H        ;4 - 14400 baud.
          DB   0A0H,0C2H        ;5 -  9600 baud.
          DB    40H,0C5H        ;6 -  4800 baud.
          DB    80H,0CAH        ;7 -  2400 baud.
          DB      0,0D5H        ;8 -  1200 baud.
          DB      0,0E7H        ;9 - out of range, value too high.
;********* ⠡ ⠭ ᪮  *********
TABBaud:
         DB    0FFH;  n=1,  f=57600
         DB    0FEH;  n=2,  f=28800
         DB    0FDH;  n=3,  f=19200
         DB    0FCH;  n=4,  f=14400
         DB    0FAH;  n=6,  f=9600
         DB    0F4H;  n=12, f=4800
         DB    0E8H;  n=24, f=2400
         DB    0D0H;  n=48, f=1200         ; 0062H

;*********** / ।   RS232 **********
; 室:  A = 
PutCharDel: ACALL Zad015  ;প 1,5 
PutChar:    JNB   TI,$    ; ⮢. ।.
            CLR   TI
            MOV   SBUF,A
            RET
;
;******* / । <OK; CR,LF> ************
SendOK:  MOV   A,#'O'
         ACALL PutCharDel
         MOV   A,#'K'
         SJMP  PutCharDel
CRLF:    MOV   A,#0DH
         ACALL PutCharDel
         MOV   A,#0AH
         SJMP  PutCharDel

         DB    0FFH,0FFH,0FFH    ;室   0080H

; **********   / 짮⥫  80H **********
;        ORG   0080H

         MOV   SP,#STEC
         ACALL PzuOFF          ; 몫 
         MOV   PCON,#80H       ; SMOD=1
         CLR   A
         MOV   PSW,A
         MOV   IE,A
         MOV   IP,A
         MOV   TMOD,#21H
         MOV   SCON,#52H
         MOV   TCON,#40H
         MOV   TipPZU,7FH      ; ࠭ 祭
         MOV   ClasPZU,7EH     ; /
         MOV   MyFlags,7DH     ; /
         MOV   TL1,7CH         ; /
         MOV   TH1,7CH         ; /
         AJMP  Menu            ; 室  . 
;
;*********** / ਥ   RS232 ************
; 室: A = 
GetChar: JNB   RI,$;    ਥ
         CLR   RI;      䫠 ਥ
         MOV   A,SBUF
         RET
;
;******* / । ப    RS232 *******
; 室: DPTR =  1- ᨬ
; ப  稢 "00"
; ଠ ।: .....,<0D>,<0A>
SendStr: CLR   A
         MOVC  A,@A+DPTR;   ᨬ
         JZ    CRLF;         ப
         JNB   BitWin,SS1;  DOS
         ACALL DosWin;      ४஢
SS1:     ACALL PutCharDel
         INC   DPTR
         SJMP  SendStr
;
; SENDS THE TEXT STRING THAT FOLLOWS THE CALL
; TO THE SERIAL PORT. IT MESSES UP THE DPTR AND ACC,
; AND ALTHOUGH IS NOT ENDED WITH A RET, MUST BE
; CALLED. THE TEXT STRING MUST END WITH AN NUL
;
XString:
        POP     DPH          ;LOAD DPTR WITH FIRST CHAR
        POP     DPL
XSTR_1: CLR     A            ;(ZERO OFFSET)
        MOVC    A,@A+DPTR    ;FETCH FIRST CHAR IN STRING
        JZ      XSTR_2
        JNB     BitWin,XSTR_3; DOS
        ACALL   DosWin
XSTR_3: ACALL   PutCharDel   ;OUTPUT CHARACTER
        INC     DPTR         ;BUMP POINTER
        SJMP    XSTR_1
XSTR_2: MOV     A,#1
        JMP     @A+DPTR      ;RETURN TO CODE AFTER NUL
;
;*********** / ४஢ DOS--->WIN/KOI-8 *************
; 室: A -  DOS    室: A -  WIN
;
DosWin:  CJNE  A,#128,DW03
DW03:    JC    DW07;       <128
         CJNE  A,#176,DW04
DW04:    JNC   DW02;       >175
         ADD   A,#64;      ४஢ 128-175
DW01:    JNB   BitKOI,DW07 ; WIN
         CLR   C
         SUBB  A,#191      ; A=1...64
         SJMP  WinKoi      ; ४஢ WIN/KOI-8
DW02:    CJNE  A,#224,DW05
DW05:    JC    DW01;        <224
         CJNE  A,#240,DW06
DW06:    JNC   DW01;        >239
         ADD   A,#16;       ४஢ 224-239
         SJMP  DW01
DW07:    RET
;
WinKoi:  MOVC  A,@A+PC    ; WIN - KOI-8
         RET
         DB    225,226,247,231,228,229,246,250,233,234
         DB    235,236,237,238,239,240,242,243,244,245
         DB    230,232,227,254,251,253,255,249,248,252
         DB    224,241,193,194,215,199,196,197,214,218
         DB    201,202,203,204,205,206,207,208,210,211
         DB    212,213,198,200,195,222,219,221,223,217
         DB    216,220,192,209
;
;**** / ॢ . ᨬ  . ॣ.  孨 ***
;室:  - ᨬ;   室:  - ᨬ  孥 ॣ
TrnLow:  CJNE  A,#61H,TL01
TL01:    JC    TL02;        < a
         CJNE  A,#7BH,TL03
TL03:    JNC   TL02;        > z
         CLR   C
         SUBB  A,#20H;      a ... z
TL02:    RET
;
;******** / ࠭ ᫥ ᨬ.   *********
BackSpc: DEC   R0
         DEC   R1
         MOV   A,#08H
         ACALL PutCharDel
         MOV   A,#20H
         ACALL PutCharDel
         MOV   A,#08H
         AJMP  PutCharDel
; AscHex - See if char in ACC is ASCII-hex and if so convert to a hex nibble.
;   Returns nibble in A, HexFlag tells if char was really hex. The ACC is not
;   altered if the character is not ASCII hex. Upper and lower case letters
;   are recognized.

AscHex:     CJNE     A,#'0',AH1        ; Test for ASCII numbers.
AH1:        JC       AHBad             ; Is character is less than a '0'?
            CJNE     A,#'9'+1,AH2      ; Test value range.
AH2:        JC       AHVal09           ; Is character is between '0' and '9'?
            CJNE     A,#'A',AH3        ; Test for upper case hex letters.
AH3:        JC       AHBad             ; Is character is less than an 'A'?
            CJNE     A,#'F'+1,AH4      ; Test value range.
AH4:        JC       AHValAF           ; Is character is between 'A' and 'F'?
            CJNE     A,#'a',AH5        ; Test for lower case hex letters.
AH5:        JC       AHBad             ; Is character is less than an 'a'?
            CJNE     A,#'f'+1,AH6      ; Test value range.
AH6:        JNC      AHBad             ; Is character is between 'a' and 'f'?
            CLR      C
            SUBB     A,#27h            ; Pre-adjust character to get a value.
            SJMP     AHVal09           ; Now treat as a number.
AHBad:      CLR      HexFlag           ; Flag char as non-hex, don't alter.
            SJMP     AHEX              ; Exit
AHValAF:    CLR      C
            SUBB     A,#7              ; Pre-adjust character to get a value.
AHVal09:    CLR      C
            SUBB     A,#'0'            ; Adjust character to get a value.
            SETB     HexFlag           ; Flag character as 'good' hex.
AHEX:       RET
;
; HexAsc - Convert a hexadecimal nibble to its ASCII character equivalent.

HexAsc:     ANL      A,#0Fh            ; Make sure we're working with only
                                       ;   one nibble.
            CJNE      A,#0Ah,HA1       ; Test value range.
HA1:        JC        HAVal09          ; Value is 0 to 9.
            ADD       A,#7             ; Value is A to F, extra adjustment.
HAVal09:    ADD       A,#'0'           ; Adjust value to ASCII hex.
            RET
;
; PrByte - Send a byte out the serial port in ASCII hexadecimal format.

PrByte: PUSH    ACC              ; Print ACC contents as ASCII hex.
        SWAP    A
        ACALL   HexAsc           ; Print upper nibble.
        ACALL   PutCharDel
        POP     ACC
        ACALL   HexAsc           ; Print lower nibble.
        ACALL   PutCharDel
        RET
;
;********* / ⪨  ஢ન  **************
XClear: ACALL   XString
        DB      0DH,0AH,' ? (Y/N)',0
        ACALL   GetPut
        ACALL   TrnLow           ;  孨 ॣ
        CJNE    A,#'N',XCL1      ;  N
        RET
XCL1:   CJNE    A,#'Y',XCL2      ;  Y
        SJMP    Clear
XCL2:   MOV     DPTR,#MesErr
        ACALL   SendStr
        SJMP    XClear
Clear:  ACALL   XString
        DB      0DH,0AH,'Memory clearing...',0
        MOV     DPTR,#0000
CL01:   MOV     A,#0FFH
        MOVX    @DPTR,A
        INC     DPTR
        MOV     A,DPH
        ANL     A,#MaskaOZU; ᪠ . 
        ORL     A,DPL
        JNZ     CL01
        MOV     DPTR,#0000
CL02:   MOVX    A,@DPTR;       ஢ઠ
        CJNE    A,#0FFH,CLERR; 訡
        INC     DPTR
        MOV     A,DPH
        ANL     A,#MaskaOZU; ᪠ .  ( ࠡ  )
        ORL     A,DPL
        JNZ     CL02
        ACALL   XString
        DB      'done',0DH,0AH,0
        RET
CLERR:  PUSH    DPH
        PUSH    DPL
        ACALL   XString
        DB      'Error at ',0
        POP     DPL
        POP     DPH
        MOV     A,DPH
        ACALL   PrByte
        MOV     A,DPL
        ACALL   PrByte
        MOV     A,#'H'
        ACALL   PutCharDel
        RET
;
;************ / প 50ms ******************
ZadUART: PUSH 07H
         PUSH 06H
         MOV  R6,#100
         SJMP ZDR
;
;************ / প 10ms ********************
Zad10:   PUSH  07H;        R7
         PUSH  06H;        R6
         MOV   R6,#14H;    20D
ZDR:     MOV   R7,#00
         DJNZ  R7,$
         DJNZ  R6,ZDR
         POP   06H;        R6
         POP   07H;        R7
         RET
;
;************ / প 1ms *********************
Zad01:   PUSH  07H;        R7
         PUSH  06H;        R6
         MOV   R6,#02
         SJMP  ZDR
;
;************ / প 100mcs ******************
Zad001:  PUSH  07H;        R7
         MOV   R7,#42
         DJNZ  R7,$
         POP   07H;        R7
         RET
;
;************ / প 1,5ms *******************
Zad015:  PUSH  07H
         PUSH  06H
         MOV   R6,#03
         SJMP  ZDR
;
; *************** / 몫祭  ***************
PzuOFF:  MOV   P3,#BB55+Vc5Vp5 ;Vpp=Vcc, .  55
PzuOFFM: MOV   R1,#RUS
         MOV   A,#PABCIN
         MOV   P1,#00
         MOVX  @R1,A           ;PA,PB,PC - , Vcc 몫.
         MOV   P3,#OZU+Vc5Vp5  ;Vpp=V, .  
         RET
;
;   । ᪮
;   Attempts to detect baud rate from first received character, by measuring
;   the length of the character. Some characters may not work properly,
;   primarily those that end with more than 2 ones in a row.
;
AutoBaud: MOV   TMOD,#21h       ;Initialize timer 0 (UART baud rate timer).
          MOV   TH0,#0C0H       ;Put timer 0 in 16-bit counter mode.
          CLR   A
          MOV   TL0,A           ;TC1- ⠩  १., GATE=0
          MOV   TCON,A
          MOV   CharH,#0C0H     ;Initialize timer result.
          MOV   CharL,A
AB0:      JB    P3.0,AB0        ;Wait for serial start bit.
          SETB  TR0             ;Start timer 0.
AB1:      JB    TF0,AB3         ;Check for timer overflow.
          JNB   P3.0,AB1        ;Check for a rising edge on serial data.
AB4:      MOV   A,TH0           ;Capture timer value at this serial edge.
          MOV   CharL,TL0
          CJNE  A,TH0,AB4
          MOV   CharH,A
AB2:      JB    TF0,AB3         ;Check for timer overflow.
          JB    P3.0,AB2        ;Check for falling edge on serial data.
          SJMP  AB1             ;Go back and repeat sampling.
AB3:      CLR   TR0             ;Maximum sample time has expired, check result.
          CLR   TF0             ;Begin by stopping timer and clearing flag.
          MOV   BaudRate,#NBaud*2+3    ;Set up table pointers.
CmpLoop:  MOV   A,BaudRate
          MOV   DPTR,#CmpTable
          MOVC  A,@A+DPTR       ;Get a table entry for comparison.
          DEC   BaudRate
          CJNE  A,CharH,Cmp1    ;Check result range.
          SJMP  CmpLow          ;High byte table = timed value, check low byte.
Cmp1:     JC    CmpMatch        ;A match if table value is < timed value.
          DJNZ  BaudRate,CmpLoop ;Check for end of comparison table.
          SJMP  CmpMatch
CmpLow:   MOV   A,BaudRate
          MOVC  A,@A+DPTR       ;Get a table entry for comparison.
          CJNE  A,CharL,Cmp2    ;Check result range.
          SETB  C               ;Match if equal.
Cmp2:     JC    CmpMatch        ;C set if A < low byte of result.
          DJNZ  BaudRate,CmpLoop ;Check for end of comparison table.
CmpMatch: MOV   A,BaudRate      ;Comparison complete,
          CLR   C               ;  get final baud rate index,
          RRC   A
          JZ    AutoBaud        ; ᪮ 
          CJNE  A,#NBaud+1,AB5
AB5:      JNC   AutoBaud        ; ᪮ 
          MOV   DPTR,#TABBaud
          DEC   A               ; ᪫ 0
          MOVC  A,@A+DPTR       ; 㧪 . ᪮
          MOV   TH1,A
          MOV   TL1,A
;
;  ।
Beg01:   MOV   SCON,#52H;  ࢮ. - ⮢. TX
         SETB  TR1;         TC1
         ACALL ZadUART;    প 50ms
         ACALL Clear;      ⪠  ஢ઠ 
BG05:    ACALL XString
         DB    0DH,0AH,'Programmer RA4NAL-2003.12 (Rescue)',0DH,0AH
         DB    'Select code page:',0DH,0AH
         DB    '<D> - DOS',0DH,0AH
         DB    '<W> - Windows',0DH,0AH
         DB    '<K> - KOI-8',0DH,0AH,0
         ACALL ZadUART
         CLR   RI
         ACALL GetPut
         ACALL TrnLow;          孨 ॣ
         CJNE  A,#'D',BG03;     DOS
         CLR   BitWin
         CLR   BitKOI
         SJMP  SelTip;        室  롮 ⨯ 
BG03:    CJNE  A,#'W',BG06;     WIN
         SETB  BitWin
         CLR   BitKOI
         SJMP  SelTip
BG06:    CJNE  A,#'K',BG04;     KOI-8
         SETB  BitWin
         SETB  BitKOI
         SJMP  SelTip
MesErr:  DB    0DH,0AH,'ERROR',0
BG04:    MOV   DPTR,#MesErr
         ACALL SendStr
         AJMP  BG05
;
;*************** / ਥ ᨬ   **********
GetPut:  ACALL GetChar
         ACALL ZadUART
         ACALL PutChar;       
         RET
;*************** 롮 ⨯  ********************
SelTip:  MOV   DPTR,#TabClas     ; ⠡ ᮢ
         ACALL SendStr
         CLR   RI;          ॡ
         ACALL GetPut
         ACALL AscHex; A =  
         MOV   ClasPZU,A; ࠭ 
         JZ    ClasErr;       = 0
         JB    HexFlag,ST01
ClasErr: MOV   DPTR,#MesErr
         ACALL SendStr
         SJMP  SelTip;   訡 
ST01:    CJNE  A,#NClas_1,ST02;   - +1
ST02:    JC    ClasOK;        ࠭ (< NClas_1)
         SJMP  ClasErr;          > NClas_1
;************* /  ⨯  **************
;室: DPTR -  砫 ⠡ ⨯ (-FF)
PrnTip:  ACALL SendStr
         INC   DPTR
         CLR   A
         MOVC  A,@A+DPTR
         CJNE  A,#0FFH,PrnTip;   ᯨ᪠
         RET
;
;******* / ᪠ ࢮ ப    ****
;室: DPTR -  砫 ⠡ ⨯
;      ClasPZU - 
;室: DPTR -  ࢮ ப  
;
SrClas:  MOV   R7,ClasPZU
PS03:    DJNZ  R7,PS01;  ࢮ ⨯  
         RET;    室   
PS01:    CLR   A
         MOVC  A,@A+DPTR
         INC   DPTR
         CJNE  A,#0FFH,PS01;   
         SJMP  PS03
;******** / ᪠ ப  ⨯   ******
;室: DPTR -  ࢮ ப  
;      TipPZU - ⨯
;室: DPTR -  ப  ⨯
;       ᫨ ப  , (TipPZU)=0
;
SrTip:   MOV   R7,TipPZU
SRT02:   DJNZ  R7,SRT01;  ப  ⨯
         RET;           ப 
SRT01:   CLR   A
         MOVC  A,@A+DPTR
         INC   DPTR
         JNZ   SRT01;      ப
         CLR   A
         MOVC  A,@A+DPTR
         CJNE  A,#0FFH,SRT02;    
         MOV   TipPZU,#00;     ᯨ᪠ 
         RET;           ப  
;
;**************  ࠭ **********************
ClasOK:  ACALL XString
         DB    0DH,0AH
         DB    '롥 ⨯ :',0DH,0AH,0
         MOV   DPTR,#TAB1; 砫 ⠡ ⨯
         ACALL SrClas
         ACALL PrnTip;       ᯨ᪠ ⨯
         CLR   RI
         ACALL GetPut
         ACALL AscHex; A = ⨯ 
         MOV   TipPZU,A; ࠭ ⨯
         JNZ   TipOK
TipErr:  MOV   DPTR,#MesErr
         ACALL SendStr
         SJMP  ClasOK;   訡  ⨯
TipOK:   JNB   HexFlag,TipErr; 訡 ⨯
;
;******************   *****************
;
Menu:    ACALL PrnPZU;     ப  ⨯
         JZ    TipErr;  訡  ⨯
         ACALL XString
         DB    0DH,0AH
         DB    'G<x> ----- RESET   x',0DH,0AH
         DB    'T -------- 롮 ⨯ ',0DH,0AH
         DB    'D<x> ----- Dump    x',0DH,0AH
         DB    'M<x> ----- ஢    x',0DH,0AH
         DB    'N x y z -- ६饭   x...y  z...',0DH,0AH
         DB    'LB ------- ⥭ BIN 䠩 c ᪠ (⮪ X-Modem)',0DH,0AH
         DB    'LH ------- ⥭ HEX 䠩  ᪠ (⮪ ASCII)',0DH,0AH
         DB    'SB ------- ࠭ BIN 䠩 (⮪ X-Modem)',0DH,0AH
         DB    'SH<y> ---- ࠭ HEX 䠩 (⮪ ASCII, 㧠 y/10 ms)',0DH,0AH
         DB    'P --------  >>>',0DH,0AH
         DB    '>',0
         ACALL GetCom;          
         CJNE  A,#0DH,MenuEnd;   ESC
         CJNE  R0,#00,Analiz ;   
MenuEnd: AJMP  Menu
;**************    ***************
Analiz:  ACALL CRLF;
         LCALL RDAtrib        ;    ਡ⮢
NePIC:   MOV   R1,#BufCom
         CJNE  @R1,#'G',NotG;  "G"
         LCALL ZadUART
         MOV   R0,#CharH;    .   ᪠.
YesG:    INC   R1
         CJNE  @R1,#20H,YesG01;  ஡
         SJMP  YesG;          ᪫ ஡
YesG01:  ACALL GetAdr;       2- ⭮ .
         PUSH  CharL
         PUSH  CharH        ;  ᪠ -  ⥪
         MOV   7FH,TipPZU   ; ࠭  室
         MOV   7EH,ClasPZU  ;/
         MOV   7DH,MyFlags  ;/
         MOV   7CH,TH1      ;/
         RET                ; 室    ⥪
NotG:    CJNE  @R1,#'T',NotT;  "T"
         AJMP  SelTip;      롮 ⨯
NotT:    CJNE  @R1,#'D',NotD;  "D"
         ACALL OutDel
         MOV   R0,#CharH;    .  ᪮. .
         ACALL GetAdr;       2- ⭮ .
         ACALL Dump8
         AJMP  Menu        ; D 믮
NotD:    CJNE  @R1,#'M',NotM;  "M"
         ACALL OutDel
         MOV   R0,#CharH;    .  ᪮. .
         ACALL GetAdr;       2- ⭮ .
         ACALL Mmr8
         AJMP  Menu        ; M 믮
NotM:    CJNE  @R1,#'N',NotN;  "N"
         ACALL MovMem
         JB    ErrFlag1,ComErr;訡 
         AJMP  Menu
NotN:    CJNE  @R1,#'L',NotL;  "L"
         INC   R1
         CJNE  @R1,#'B',NeLB;     BIN
         LCALL RXXM;            ਥ X-Modem
         AJMP  Menu
NeLB:    CJNE  @R1,#'H',ComErr;     HEX ASCII
         LCALL RXHEX;           ਥ ASCII
         AJMP  Menu
NotL:    CJNE  @R1,#'S',NotS;    "S"
         INC   R1
         CJNE  @R1,#'B',NeSB;   BIN
         LCALL TXXM;            । X-Modem
         AJMP  Menu
NeSB:    CJNE  @R1,#'H',ComErr;   HEX ASCII
         ACALL OutDel         ;  㤠 ஡   .
         MOV   R0,#CharH      ;  .  
         MOV   R6,#2          ;Max -   
         ACALL GetAdr2        ;⥭   CharL
         LCALL TXHEX          ;। ASCII
         AJMP  Menu
NotS:    CJNE  @R1,#'P',ComErr;   ணࠬ஢
         LCALL ProgPZU;          ணࠬ஢
         AJMP  Menu
ComErr:  MOV   DPTR,#MesErr
         LCALL SendStr
         AJMP  Menu;   訡  
;
;* / ᪫. ஡ *
;室: @R1 -  砫  

OutDel:  INC   R1
SW02:    CJNE  @R1,#20H,SW01;  ஡
         INC   R1
         SJMP  SW02;          ᪫ ஡
SW01:    RET
;
;********* /     **********
GetCom:  MOV   R1,#BufCom;   砫  
         MOV   R0,#0;        稪 ᨬ 
         CLR   RI
GC07:    LCALL GetChar
         LCALL ZadUART
         CJNE  A,#0DH,GC03;   Enter
         MOV   @R1,#20H
         INC   R1
         MOV   @R1,#00
GCEND:   RET              ;   
GC03:    CJNE  A,#08H,GC04;   Backspace
         SJMP  GC05
GC04:    CJNE  A,#1BH,GC10;   ESC
         SJMP  GCEND      ;   ESC
GC10:    CJNE  A,#20H,GC06
GC06:    JC    GC07;         ࠢ. ᨬ (< 20H)
         SJMP  GC09;         뢠 ᨬ  
GC05:    CJNE  R0,#00,GC08;   砫 , ࠥ ᨬ.
         SJMP  GC07;          祣
GC08:    LCALL BackSpc;      ࠥ ᫥ ᨬ
         SJMP  GC07
GC09:    CJNE  R0,#BufLng-2,GC11;  ᨬ  
         SJMP  GC07;          
GC11:    PUSH  ACC
         LCALL TrnLow;        孨 ॣ
         MOV   @R1,A
         POP   ACC
         INC   R1
         INC   R0
         LCALL PutChar
         SJMP  GC07;         ᫥. ᨬ
;
;********** /  ப  ⨯  ***********
PrnPZU:  MOV   DPTR,#TAB1
         ACALL SrClas
         ACALL SrTip
         MOV   A,TipPZU
         JZ    PP02;  訡  ⨯
         MOV   A,#08;   ᤢ  8 ᨬ.  砫 ப
         ADD   A,DPL
         MOV   DPL,A
         JNC   PP01
         INC   DPH
PP01:    ACALL CRLF
         ACALL CRLF
         ACALL SendStr;  ப  ⨯
         MOV   A,#0FFH; ਧ,  ⨯ ࠭
PP02:    RET
;
;** /  2- ⭮ ᫠    **
;室: @R0 -   .  ᫠
;      @(R0+1) -   . 
;      @R1 -  ࢮ ASCII    
GetAdr:  MOV   R6,#04;   max -   
GetAdr2: MOV   @R0,#00;  . 
         INC   R0
         MOV   @R0,#00;  . 
GA02:    MOV   A,@R1;      
         LCALL AscHex
         JNB   HexFlag,GETEND;   HEX 
         PUSH  ACC
;ᤢ 2-   ࠤ 
         MOV   R7,#04;   ࠤ
GA01:    CLR   C
         MOV   A,@R0;    . 
         RLC   A
         MOV   @R0,A
         DEC   R0
         MOV   A,@R0;    . 
         RLC   A
         MOV   @R0,A
         INC   R0
         DJNZ  R7,GA01
         POP   ACC
         XCHD  A,@R0;   . ࠤ  -  
         INC   R1;      . ᫥.   
         DJNZ  R6,GA02
GETEND:  RET
;
;********** / 뢮 DUMP-  ⠬  ************
;室:CharH - .  
;     CharL - .  
Dump8:  MOV     DPH,CharH       ;PUT START ADDR IN DPTR
        MOV     A,CharL
        ANL     A,#0F0H         ;START ON 16-BYTE BOUNDARY
        MOV     DPL,A           ;HAVE START ADDRESS IN DPTR
DM801:  MOV     R7,#16          ;SET UP ROW COUNTER
        LCALL   CRLF            ;GO TO NEXT LINE TO START
LOUT8:  MOV     R6,#16          ;SET UP BYTE COUNTER
        MOV     A,DPH           ;AT START OF LINE OUTPUT ADDR
        LCALL   PrByte
        MOV     A,DPL
        LCALL   PrByte
        MOV     A,#':'
        LCALL   PutCharDel
        MOV     A,#' '
        LCALL   PutCharDel
        push    dpl
        push    dph             ;save line start address on stack
BOUT8:  MOVX    A,@DPTR         ;OUTPUT ROW ONE BYTE AT A TIME
        LCALL   PrByte
        MOV     A,#' '
        LCALL   PutCharDel
        INC     DPTR
        DJNZ    R6,BOUT8        ;END OF BYTE LOOP
        pop     dph
        pop     dpl             ;restore line start address
        ACALL   dascii          ;display ascii equivalents
        LCALL   CRLF            ;GO TO NEXT LINE
        DJNZ    R7,LOUT8        ;LOOP THROUGH NEXT LINE IF REQ'D
        CLR     RI              ;ॡ
        ACALL   GetPut
        LCALL   TrnLow          ; 孨 ॣ
        CJNE    A,#'D',DM802    ; D
        SJMP    DM801           ; ࠭
DM802:  CJNE    A,#0DH,D8End    ; Enter
        SJMP    DM801
D8End:  RET
;
;******** /  ASCII ᨬ DUMP-a **********
;室:DPTR -  1- 
dascii: mov     r6,#16          ;initalize loop count
        mov     a,#' '
        LCALL   PutCharDel      ;put out couple of spaces
        LCALL   PutCharDel
dasci1: movx    a,@dptr         ;get the byte
        CJNE    A,#20H,dasci3
dasci3: JNC     dasci2;         ;⠥ ᨬ (>20h)
        MOV     A,#'.'          ; ⠥ ᨬ (<20h)
dasci2: JNB     BitWin,dasci4   ;DOS
        LCALL   DosWin          ;४஢ WIN-->DOS
dasci4: LCALL   PutCharDel      ;print it
        inc     dptr            ;bump data pointer
        djnz    r6,dasci1       ;and loop 'till done
        ret                     ;return and do next line
;
;********** /     **************
;室: CharH - . .  
;      CharL - . .  
;
Mmr8:   MOV     DPH,CharH       ;GET THE UPPER ADDRESS BYTE
        MOV     DPL,CharL       ;GET THE LOWER ADDRESS BYTE
MM01:   ACALL   CRLF            ;GO TO A NEW LINE
        MOV     A,DPH           ;SHOW THE ADDRESS
        LCALL   PrByte
        MOV     A,DPL
        LCALL   PrByte
        MOV     A,#':'          ;SPACE BETWEEN ADDRESS AND DATA
        LCALL   PutCharDel
        MOV     A,#' '
        LCALL   PutCharDel
        MOVX    A,@DPTR         ;SHOW THE CURRENT DATA
        LCALL   PrByte
        MOV     A,#' '
        LCALL   PutCharDel      ;OUTPUT A SPACE
        ACALL   GetCom          ;GET THE NEW DATA
        MOV     R1,#BufCom      ;砫  
        CJNE    @R1,#' ',MM02   ;ITS NOT A SPACE SO KEEP CHECKING
        INC     DPTR            ;SPACE, SO SHOW NEXT LOCATION
        SJMP    MM01
MM02:   MOV     R0,#CharH1      ;  .   ᫠
        MOV     R6,#2           ;Max -   
        ACALL   GetAdr2         ;⥭   CharL1
        JNB     HexFlag,MEMX    ; HEX , 室
        MOV     A,CharL1
        MOVX    @DPTR,A         ;MOVE THE NEW VALUE TO MEMORY
        MOV     A,#' '
        LCALL   PutCharDel      ;஡
        LCALL   PutCharDel      ;஡
        LCALL   PutCharDel
        MOVX    A,@DPTR         ; ⥭
        LCALL   PrByte          ;뢮 ⠭ 祭
        INC     DPTR            ;POINT TO NEXT LOCATION
        SJMP    MM01            ;AND CONTINUE
MEMX:   RET                     ;BACK FOR NEXT COMMAND

; / ६饭 
; 室: @R1 - 砫  
; 室: ErrFlag1=0, ᫨  믮
; ᯮ: CharH,  CharL  - 砫 㤠
;               CharH1, CharL1 -   㤠
;               CharH2, CharL2 - 砫 㤠
;               HaSave, LaSave -   㤠

MovErr1: LJMP  MovErr
MovMem:  LCALL OutDel       ;᪫ ஡
         MOV   A,@R1
         JZ    MovErr1      ;   ᮢ
         LCALL VVAdr        ; ᮢ "㤠"
         JB    ErrFlag1,MovErr ; 訡 
         LCALL OutDel
         MOV   R0,#CharH2  ;.. .."㤠"
         LCALL GetAdr
         CJNE  @R1,#20H,MovErr ;  4- 
         CLR   C
         MOV   A,CharL1
         SUBB  A,CharL
         MOV   LaSave,A
         MOV   A,CharH1
         SUBB  A,CharH
         MOV   HaSave,A
         MOV   A,LaSave
         ADD   A,CharL2
         MOV   LaSave,A    ;.  .."㤠"
         MOV   A,HaSave
         ADDC  A,CharH2
         MOV   HaSave,A    ;.  .."㤠"
         JC    MovErr      ;९, 訡
         MOV   A,CharL2    ; C=0
         SUBB  A,CharL
         MOV   A,CharH2
         SUBB  A,CharH
         JC    MovNiz      ;㤠 < 㤠
; ७ 㤠 < 㤠
         MOV   DPL,CharL1
         MOV   DPH,CharH1  ; 㤠
MovVerh: MOVX  A,@DPTR     ;  
         PUSH  DPL
         PUSH  DPH
         MOV   DPL,LaSave  ; 㤠
         MOV   DPH,HaSave
         MOVX  @DPTR,A     ;   
         LCALL DecDPTR     ;᫥ . 㤠
         MOV   LaSave,DPL  ;࠭
         MOV   HaSave,DPH
         POP   DPH
         POP   DPL
         MOV   A,CharL     ;ࠢ . ⥪. 㤠
         XRL   A,DPL
         JNZ   MovVr1      ; ࠢ
         MOV   A,CharH
         XRL   A,DPH
         JZ    MvEnd1      ;ࠢ, 室
MovVr1:  LCALL DecDPTR     ;᫥. . 㤠
         SJMP  MovVerh
MovErr:  SETB  ErrFlag1
         SJMP  MovEnd
MvEnd1:  LCALL SendOK
MovEnd:  RET
; ७ 㤠 < 㤠
MovNiz:  MOV   DPL,CharL
         MOV   DPH,CharH   ;砫 㤠
MovNz1:  MOVX  A,@DPTR     ;  
         PUSH  DPL
         PUSH  DPH
         MOV   DPL,CharL2  ;砫 㤠
         MOV   DPH,CharH2
         MOVX  @DPTR,A     ;   
         INC   DPTR        ;᫥ . 㤠
         MOV   CharL2,DPL  ;࠭
         MOV   CharH2,DPH
         POP   DPH
         POP   DPL
         MOV   A,CharL1   ;ࠢ . ⥪. 㤠
         XRL   A,DPL
         JNZ   MovNz2      ; ࠢ
         MOV   A,CharH1
         XRL   A,DPH
         JZ    MvEnd1      ;ࠢ, 
MovNz2:  INC   DPTR        ;᫥. . 㤠
         SJMP  MovNz1
;
; / DEC DPTR
DecDPTR: CLR   C
         MOV   A,DPL
         SUBB  A,#1
         MOV   DPL,A
         MOV   A,DPH
         SUBB  A,#0
         MOV   DPH,A
         RET
;
;************* ਥ HEX ASCII ******************
;
RXHEX:      LCALL    XClear            ; ⪠ 
            LCALL    XString
            DB       0DH,0AH,'㧪 HEX 䠩 (⮪ ASCII)...',0
            LCALL    HexIn             ; Clear out some variables.
StateLoop:  LCALL    GetChar           ; Get a character for processing.
            LCALL    AscHex            ; Convert ASCII-hex character to hex.
            MOV      Lh,A              ; Save result for later.
            LCALL    GoState           ; Go find the next state based on
                                       ;   this char.
            JNB      DoneFlag,StateLoop; Repeat until done or terminated.
            LCALL    ErrPrt
StateL1:    CLR      RI
            LCALL    ZadUART
            JB       RI,StateL1        ;   ।
            RET
;
HexIn:      CLR      A                 ; Clear out some variables.
            MOV      State,A
            MOV      Flags,A
            MOV      HighAddr,A
            MOV      LowAddr,A
            MOV      HaSave,A
            MOV      LaSave,A
            MOV      ChkSum,A
            MOV      FilChkHi,A
            MOV      FilChkLo,A
            MOV      EFlags,A
            SETB     ErrFlag4          ; Start with a 'no data' condition.
            RET
;
; /   ।
PURGE:      MOV      DPTR,#0000
            CLR      RI
PURG1:      INC      DPTR
            MUL      AB
            MUL      AB
            MUL      AB
            MOV      A,DPH
            CJNE     A,#0FFH,PURG1    ;  1ᥪ
            JB       RI,PURGE         ; ᭮ 
            RET
;
;************* ਥ BIN 䠩  X-MODEM *****************
;
RXXM:       LCALL    XClear            ; ⪠ 
            LCALL    XString
            DB       0DH,0AH,'㧪 BIN 䠩 (⠭ ⮪ X-Modem)...',0
            LCALL    HexIn       ; Clear out some variables.
            MOV      BlkN,#01    ;  
            CLR      RI
RXX02:      MOV      R7,#04H
RXX05:      MOV      DPTR,#0000
RXX01:      JBC      RI,RXX03    ;  ਭ
            INC      DPTR
            MOV      A,DPH
            CJNE     A,#0FFH,RXX01     ; 
            DJNZ     R7,RXX05          ;  4 ࠧ
            MOV      A,#NAK
            LCALL    PutChar     ; 뫠 NAK
            SJMP     RXX02        ; ᭮ 
RXX03:      MOV      A,SBUF       ; ਭ 
            CJNE     A,#SOH,RXX04 ; 訡
            LCALL    GetChar
            CJNE     A,BlkN,RXX04 ; 訡 
            LCALL    GetChar
            CPL      A
            CJNE     A,BlkN,RXX04 ; 訡 
            SJMP     RXBlk        ; ਥ  
RXX04:      LCALL    PURGE        ;   ।
            MOV      A,#CAN       ; 뢠 ।
            LCALL    PutChar
RXX07:      MOV      R7,#20
RXX06:      LCALL    ZadUART
            DJNZ     R7,RXX06     ;  1ᥪ
            LCALL    XString
            DB       0DH,0AH,'訡 ⮪',0DH,0AH,0
            RET
;
; ਥ  
;
RXBlk:      MOV      DPTR,#0000    ; .  
            CLR      ErrFlag4      ;  
RXB13:      MOV      ChkSum,#00    ; KC
RXB01:      LCALL    GetChar
            MOVX     @DPTR,A
            MOV      Lh,A
            MOVX     A,@DPTR
            CJNE     A,Lh,RXB08    ; 訡 
            ADD      A,ChkSum
            MOV      ChkSum,A      ;KC
            INC      DPTR          ; ᫥. 
            CLR      A
            CJNE     A,DPH,RXB09
            CJNE     A,DPL,RXB09
            SETB     ErrFlag5      ;  
RXB09:      MOV      A,DPL
            JZ       RXB02         ;  
            CJNE     A,#80H,RXB01  ;   
RXB02:      LCALL    GetChar
RXB07:      PUSH     ACC           ; c࠭ ᨬ
            CJNE     A,ChkSum,RXB03; 訡 
            MOV      A,#ACK
            SJMP     RXB10
RXB03:      MOV      A,#NAK
RXB10:      LCALL    Zad001        ; 100mks
            LCALL    PutChar       ; ⢥
            MOV      R7,#00
RXB06:      MOV      R6,#00
RXB05:      JBC      RI,RXB04      ;  ਭ
            MUL      AB
            DJNZ     R6,RXB05
            DJNZ     R7,RXB06      ;  0,6cek
            POP      ACC
            SJMP     RXB07         ; ᭮ ⢥
RXB04:      POP      ACC
            MOV      A,SBUF        ; ਭ 
            CJNE     A,#SOH,RXL05  ;  砫 
            LCALL    GetChar
            CJNE     A,BlkN,RXL06  ;  ।騩 
            LCALL    GetChar
            CPL      A
            CJNE     A,BlkN,RXL11  ; 訡 
            MOV      A,DPL
            JNZ      RXL10         ;  0
            DEC      DPH
            MOV      DPL,#80H
            AJMP     RXB13         ;  ਥ 
RXL10:      CJNE     A,#80H,RXL11
            MOV      DPL,#00
            AJMP     RXB13
RXB08:      SETB     ErrFlag6      ; 訡 
            LCALL    PURGE
            MOV      A,#CAN
            LCALL    PutChar
RXB12:      MOV      R7,#20
RXB11:      LCALL    ZadUART
            DJNZ     R7,RXB11
            LCALL    ErrPrt
            RET                    ; 室
RXL11:      LJMP     RXX04         ; 訡
RXL06:      INC      BlkN          ; ᫥.  
            CJNE     A,BlkN,RXL11  ; 訡 
            LCALL    GetChar
            CPL      A
            CJNE     A,BlkN,RXL11  ; 訡 
            LJMP     RXB13         ; ਥ ᫥. 
RXL05:      CJNE     A,#EOT,RXL11  ; 訡 
            LCALL    Zad001        ; 100mks
            MOV      A,#ACK
            LCALL    PutChar
            SJMP     RXB12         ;  ਥ
;
;************ Hexadecimal File Input Routine **************
; Find and execute the state routine pointed to by "State".
;
GoState:    MOV      A,State           ; Get current state.
            ANL      A,#0Fh            ; Insure branch is within table range.
            RL       A                 ; Adjust offset for 2 byte insts.
            MOV      DPTR,#StateTable
            JMP      @A+DPTR           ; Go to appropriate state.
;
StateTable: AJMP     StWait            ;  0 - Wait for start.
            AJMP     StLeft            ;  1 - First nibble of count.
            AJMP     StGetCnt          ;  2 - Get count.
            AJMP     StLeft            ;  3 - First nibble of address byte 1.
            AJMP     StGetAd1          ;  4 - Get address byte 1.
            AJMP     StLeft            ;  5 - First nibble of address byte 2.
            AJMP     StGetAd2          ;  6 - Get address byte 2.
            AJMP     StLeft            ;  7 - First nibble of record type.
            AJMP     StGetRec          ;  8 - Get record type.
            AJMP     StLeft            ;  9 - First nibble of data byte.
            AJMP     StGetDat          ; 10 - Get data byte.
            AJMP     StLeft            ; 11 - First nibble of checksum.
            AJMP     StGetChk          ; 12 - Get checksum.
            AJMP     StSkip            ; 13 - Skip data after error condition.
            AJMP     BadState          ; 14 - Should never get here.
            AJMP     BadState          ; 15 -   "      "    "    "
;
; This state is used to wait for a line start character. Any other characters
;   received prior to the line start are simply ignored.
;
StWait:     MOV      A,Lh              ; Retrieve input character.
            CJNE     A,#StartChar,SWEX1; Check for line start.
            INC      State             ; Received line start.
SWEX:       RET
SWEX1:      CJNE     A,#1BH,SWEX       ;  Esc
            SETB     ErrFlag1          ; Esc, ⬥ ਥ
            SETB     DoneFlag
            RET
;
; Process the first nibble of any hex byte.
;
StLeft:     MOV      A,Lh              ; Retrieve input character.
            JNB      HexFlag,SLERR     ; Check for hex character.
            ANL      A,#0Fh            ; Isolate one nibble.
            SWAP     A                 ; Move nibble too upper location.
            MOV      DataByte,A        ; Save left/upper nibble.
            INC      State             ; Go to next state.
            RET                        ; Return to state loop.
SLERR:      SETB     ErrFlag1          ; Error - non-hex character found.
            SETB     DoneFlag          ; File considered corrupt. Tell main.
            RET
;
; Process the second nibble of any hex byte.
;
StRight:    MOV      A,Lh              ; Retrieve input character.
            JNB      HexFlag,SRERR     ; Check for hex character.
            ANL      A,#0Fh            ; Isolate one nibble.
            ORL      A,DataByte        ; Complete one byte.
            MOV      DataByte,A        ; Save data byte.
            ADD      A,ChkSum          ; Update line checksum,
            MOV      ChkSum,A          ;   and save.
            RET                        ; Return to state loop.
SRERR:      SETB     ErrFlag1          ; Error - non-hex character found.
            SETB     DoneFlag          ; File considered corrupt. Tell main.
            RET
;
; Get data byte count for line.
;
StGetCnt:   ACALL    StRight           ; Complete the data count byte.
            MOV      A,DataByte
            MOV      ByteCount,A
            INC      State             ; Go to next state.
            RET                        ; Return to state loop.
;
; Get upper address byte for line.
;
StGetAd1:   ACALL    StRight           ; Complete the upper address byte.
            MOV      A,DataByte
            MOV      HighAddr,A        ; Save new high address.
            INC      State             ; Go to next state.
            RET                        ; Return to state loop.
;
; Get lower address byte for line.
;
StGetAd2:   ACALL    StRight           ; Complete the lower address byte.
            MOV      A,DataByte
            MOV      LowAddr,A         ; Save new low address.
            INC      State             ; Go to next state.
            RET                        ; Return to state loop.
;
; Get record type for line.
;
StGetRec:   ACALL    StRight           ; Complete the record type byte.
            MOV      A,DataByte
            MOV      RecType,A         ; Get record type.
            JZ       SGRDat            ; This is a data record.
            CJNE     A,#1,SGRErr       ; Check for end record.
            SETB     EndFlag           ; This is an end record.
            SETB     DatSkipFlag       ; Ignore data embedded in end record.
            MOV      State,#11         ; Go to checksum for end record.
            SJMP     SGREX
SGRDat:     INC      State             ; Go to next state.
SGREX:      RET                        ; Return to state loop.
SGRErr:     SETB     ErrFlag2          ; Error, bad record type.
            SETB     DoneFlag          ; File considered corrupt. Tell main.
            RET
;
; Get a data byte.
;
StGetDat:   ACALL    StRight           ; Complete the data byte.
            JB       DatSkipFlag,SGD1  ; Don't process the data if the skip
                                       ;   flag is on.
            ACALL    Store             ; Store data byte in memory.
            MOV      A,DataByte        ; Update the file checksum,
            ADD      A,FilChkLo        ;   which is a two-byte summation of
            MOV      FilChkLo,A        ;   all data bytes.
            CLR      A
            ADDC     A,FilChkHi
            MOV      FilChkHi,A
            MOV      A,DataByte
SGD1:       DJNZ     ByteCount,SGDEX   ; Last data byte?
            INC      State             ; Done with data, go to next state.
            SJMP     SGDEX2
SGDEX:      DEC      State             ; Set up state for next data byte.
SGDEX2:     RET                        ; Return to state loop.
;
; Get checksum.
StGetChk:   ACALL    StRight           ; Complete the checksum byte.
            JNB      EndFlag,SGC1      ; Check for an end record.
            SETB     DoneFlag          ; If this was an end record,
            SJMP     SGCEX             ;  we are done.
SGC1:       MOV      A,ChkSum          ; Get calculated checksum.
            JNZ      SGCErr            ; Result should be zero.
            MOV      ChkSum,#0         ; Preset checksum for next line.
            MOV      State,#0          ; Line done, go back to wait state.
            MOV      LaSave,LowAddr    ; Save address byte from this line for
            MOV      HaSave,HighAddr   ;   later check.
SGCEX:      RET                        ; Return to state loop.
SGCErr:     SETB     ErrFlag3          ; Line checksum error.
            SETB     DoneFlag          ; File considered corrupt. Tell main.
            RET
;
; This state used to skip through any additional data sent, ignoring it.
StSkip:     RET                        ; Return to state loop.
;
; A place to go if an illegal state comes up somehow.
BadState:   MOV      State,#Skip       ; If we get here, something very bad
            RET                        ;   happened, so return to state loop.
;
; Store - Save data byte in external RAM at specified address.
;
Store:      MOV      DPH,HighAddr      ; Set up external RAM address in DPTR.
            MOV      DPL,LowAddr
            MOV      A,DataByte
            MOVX     @DPTR,A           ; Store the data.
            MOVX     A,@DPTR           ; Read back data for integrity check.
            CJNE     A,DataByte,StoreErr ; Is read back OK?
            CLR      ErrFlag4          ; Show that we've found some data.
            INC      DPTR              ; Advance to the next addr in sequence.
            MOV      HighAddr,DPH      ; Save the new address
            MOV      LowAddr,DPL
            CLR      A
            CJNE     A,HighAddr,StoreEx ; Check for address overflow
            CJNE     A,LowAddr,StoreEx ;   (both bytes are 0).
            SETB     ErrFlag5          ; Set warning for address overflow.
StoreEx:    RET
StoreErr:   SETB     ErrFlag6          ; Data storage verify error.
            SETB     DoneFlag          ; File considered corrupt. Tell main.
            RET
;
;/  訡 ᪮஢ 䠩
ErrPrt:  MOV    A,EFlags         ; 䫠 訡
         JNZ    ErrYes           ; 訡 
         LCALL  CRLF
         LCALL  SendOK
         RET                     ; 訡 
ErrYes:  MOV    A,#CAN
         LCALL  PutChar
         LCALL  ZadUART
         JNB    ErrFlag1,EPT01
         LCALL  XString
         DB     0DH,0AH,'  HEX 䠩',0
EPT01:   JNB    ErrFlag2,EPT02
         LCALL  XString
         DB     0DH,0AH,'⨬ ଠ HEX 䠩',0
EPT02:   JNB    ErrFlag3,EPT03
         LCALL  XString
         DB     0DH,0AH,'訡 ஫쭮 㬬',0
EPT03:   JNB    ErrFlag4,EPT04
         LCALL  XString
         DB     0DH,0AH,'   䠩',0
EPT04:   JNB    ErrFlag5,EPT05
         LCALL  XString
         DB     0DH,0AH,' ',0
EPT05:   JNB    ErrFlag6,ERREX
         LCALL  XString
         DB     0DH,0AH,'訡   ',0
ERREX:   RET
;
;******** /     ਡ⮢ *******
; 室: ClasPZU, TipPZU
;       TabDLPZU - 砫 ⠡
; 室: HaSave, LaSave -   (  ਥ HEX)
;        AtribPZU - ਡ
;          0FFH
;
RDAtrib: MOV    A,ClasPZU
         JZ     Chd08          ;   ࠭
         MOV    DPTR,#TabDLPZU ; 砫 ⠡
         MOV    R7,A           ; 稪 ᮢ
Chd03:   DJNZ   R7,Chd01       ; ᫥. 
         MOV    A,TipPZU       ; 室   
         JZ     Chd08          ; ⨯  ࠭
         MOV    R7,A
Chd07:   DJNZ   R7,Chd05       ; ᫥. ⨯
         CLR    A
         MOVC   A,@A+DPTR
         MOV    HaSave,A       ; .  
         INC    DPTR
         CLR    A
         MOVC   A,@A+DPTR
         MOV    LaSave,A       ; .  
         INC    DPTR
         CLR    A
         MOVC   A,@A+DPTR
         MOV    AtribPZU,A     ; ਡ
         RET                   ; 室  ᯥ譮 ⥭
Chd05:   CLR    A
         INC    DPTR
         INC    DPTR
         INC    DPTR
         MOVC   A,@A+DPTR
         CJNE   A,#0FFH,Chd07  ;   ⨯
Chd08:   MOV    DPTR,#MesErr
         LCALL  SendStr
         RET                   ; 室  訡
Chd01:   CLR    A
         INC    DPTR
         INC    DPTR
         INC    DPTR
         MOVC   A,@A+DPTR
         CJNE   A,#0FFH,Chd01  ;   ⨯  
         INC    DPTR           ; ய᪠ FF
         SJMP   Chd03          ;  , 室  ᫥.
;
;************ । HEX 䠩 (ASCII) *********
; 室: HEXPIC=1 PIC, =0  PIC
;       NotFlash=1  FLASH, =0 FLASH
;       HaSave - .  +1
;       LaSave - .  +1
;       CharL  - 㧠  ᨬ (1=100)
;
; / ᫥ 
ApdCS:   PUSH    ACC
         ADD     A,ChkSum
         MOV     ChkSum,A
         POP     ACC
         RET
;
; /   ᨬ  ।
; 室: CharL - - থ  100
;
SymDel:  MOV    R5,CharL      ; - থ  100
         CJNE   R5,#00,SD01   ; 㧠 
         RET                  ;  
SD01:    LCALL  Zad001        ; 100mcs
         DJNZ   R5,SD01
         RET
;
; / । PrByte  প
;
DelPrByte: PUSH    ACC              ; Print ACC contents as ASCII hex.
           SWAP    A
           LCALL   HexAsc           ; Print upper nibble.
           ACALL   SymDel
           LCALL   PutChar
           POP     ACC
           LCALL   HexAsc           ; Print lower nibble.
           ACALL   SymDel
           LCALL   PutChar
           RET
;
; / । ப HEX 䠩
; 室: DPTR - .  
;
StrHex:  MOV     ChkSum,#00
         MOV     A,#':'
         ACALL   SymDel
         LCALL   PutChar
         MOV     A,#10H        ; -   ப
         MOV     R7,A
         ACALL   ApdCS
         ACALL   DelPrByte
         MOV     A,DPH         ; .  
         ACALL   ApdCS
         ACALL   DelPrByte
         MOV     A,DPL         ; .  
         ACALL   ApdCS
         ACALL   DelPrByte
         CLR     A
         ACALL   DelPrByte        ; ⨯ ()
SH03:    MOVX    A,@DPTR       ;   
         ACALL   ApdCS
         ACALL   DelPrByte
         INC     DPTR
         DJNZ    R7,SH03       ; 16 
         CLR     A
         CLR     C
         SUBB    A,ChkSum
         ACALL   DelPrByte
SH07:    ACALL   SymDel
         MOV     A,#0DH
         LCALL   PutChar
         ACALL   SymDel
         MOV     A,#0AH
         LCALL   PutChar
         RET
;
TXHEX:   CLR     RI
         MOV     R6,#04        ; - ᨬ.  뢠 RX
         MOV     DPTR,#0000    ; . 
SH04:    ACALL   StrHex
         JNB     RI,SH08       ;  뫮 ᨬ.  ਥ
         CLR     RI
         DJNZ    R6,SH08       ;   뢠
         AJMP    TXXInt        ; । ࢠ, 室
SH08:    MOV     A,DPH
         CJNE    A,HaSave,SH04 ; .    ࠢ .
         MOV     A,DPL
         CJNE    A,LaSave,SH04 ; .    ࠢ .
         MOV     A,#':'
         ACALL   SymDel
         LCALL   PutChar
         CLR     A
         ACALL   DelPrByte
         CLR     A
         ACALL   DelPrByte
         CLR     A
         ACALL   DelPrByte
         MOV     A,#01H
         ACALL   DelPrByte
         MOV     A,#0FFH
         ACALL   DelPrByte
         ACALL   SH07         ; । CRLF
         CLR     RI
         LCALL   GetChar
         RET
;
;************ । BIN 䠩 (X-Modem) *******
; 室: HEXPIC=1 PIC, =0  PIC
;       NotFlash=1  FLASH, =0 FLASH
;       HaSave - .  +1
;       LaSave - .  +1
;
TXXM:    LCALL   XString
         DB      '롥  ନ ० <ਭ 䠩 X-Modem>...',0DH,0AH,0
         MOV     DPTR,#0000       ; 砫  
         MOV     BlkN,#01         ;  ࢮ 
         MOV     R6,#10     ; - 訡 ਥ ⢥
         CLR     A
         CJNE    A,LaSave,TXX02   ; .    0
         SJMP    TXX01            ; .  =0
TXX02:   MOV     LaSave,A         ; ᤥ =0
         INC     HaSave           ; । ⭮ 100H
TXX01:   CLR     RI
TXX04:   LCALL   GetChar
         CJNE    A,#NAK,TXX05     ;  NAK
         MOV     R6,#03           ; - 訡  ⢥
         SJMP    TXBeg            ; 砫 ।
TXX05:   CJNE    A,#CAN,TXX07     ;  CAN
TXX06:   LCALL   PURGE
TXXInt:  LCALL   XString
         DB      '। ࢠ',0DH,0AH,0
         RET
TXX07:   DJNZ    R6,TXX04      ; ᭮ ਥ
         AJMP    TXB08         ; 室  訡
TXBeg:   MOV     ChkSum,#00
         MOV     R7,#80H       ;  
         MOV     A,#SOH
         LCALL   PutChar
         MOV     A,BlkN
         LCALL   PutChar       ;  
         CPL     A
         LCALL   PutChar
TXB01:   MOVX    A,@DPTR       ;   
         ACALL   ApdCS         ;  
         LCALL   PutChar
         INC     DPTR
         DJNZ    R7,TXB01      ; । 
         MOV     A,ChkSum
         LCALL   PutChar       ; 뢮 
         LCALL   GetChar       ;  ⢥
         CJNE    A,#ACK,TXB05  ;  ACK
         MOV     R6,#03        ; - 訡  ⢥
         MOV     A,DPH
         CJNE    A,HaSave,TXB03; .   ࠢ 筮
         MOV     A,DPL
         CJNE    A,LaSave,TXB03; .   ࠢ 筮
TXB04:   MOV     A,#EOT        ; । 祭
         LCALL   PutChar
         LCALL   GetChar
         CJNE    A,#ACK,TXB04  ; ਭ  ACK
         LCALL   PURGE
         LCALL   SendOK
         RET                   ;  ।
TXB03:   INC     BlkN
         SJMP    TXBeg         ; ᫥. 
TXB05:   CJNE    A,#NAK,TXB02  ;  NAK
TXB07:   CLR     C             ; ਭ NAK
         MOV     A,DPL
         SUBB    A,#80H
         MOV     DPL,A
         JNC     TXB09         ;  
         MOV     A,DPH
         DEC     A
         MOV     DPH,A
TXB09:   AJMP    TXBeg         ;  ਥ 
TXB02:   CJNE    A,#CAN,TXB06  ;  CAN
         AJMP    TXX06         ; 뢠 ।
TXB06:   DJNZ    R6,TXB07      ;  । 
TXB08:   LCALL   PURGE
         MOV     A,#CAN
         LCALL   PutChar
         LCALL   ZadUART
         MOV     DPTR,#MesErr
         LCALL   SendStr
         RET                    ; 室  訡
;
;************ ணࠬ஢ *******************
ProgPZU: LCALL   PrnPZU         ;  ப  ⨯
         LCALL   RDAtrib        ; ⥭   ਡ⮢
         MOV     EFlags,#00     ;  䫠 訡
         LJMP    EPROM
;
;****** /   室 *******
; 室: - 
; 室: A=ᬥ饭
RSAP:    JZ      RSAErr         ;   ࠭
         DEC     A              ; 砫 ⠡
         MOV     B,#3
         MUL     AB
RSAErr:  RET
;
;****** /  ⠭ .  . ᮢ ******
;室: HaSave, LaSave -  
;室: CharH, CharL - . 
;       CharH1, CharL1 -. 
VstAdr:    CLR    A
           MOV    CharH,A
           MOV    CharL,A
           CLR    C
           MOV    A,LaSave    ; .  
           SUBB   A,#01
           MOV    CharL1,A    ; .  . 
           MOV    A,HaSave    ; .  
           SUBB   A,#00
           MOV    CharH1,A    ; .  . 
           RET
;
;***** /  ᮢ    ******
;室: @R1 -  ࢮ ASCII    
;室: CharH, CharL - . 
;       CharH1, CharL1 -. 
VVAdr:   MOV    R0,#CharH     ;  .  . 
         LCALL  GetAdr
         CJNE   @R1,#20H,VVErr;   4- 
         LCALL  OutDel        ; ᪫ ஡
         MOV    R0,#CharH1    ;  .  . 
         LCALL  GetAdr
         CJNE   @R1,#20H,VVErr;   4- 
         CLR    C
         MOV    A,CharL1
         SUBB   A,CharL
         MOV    A,CharH1
         SUBB   A,CharH
         CLR    ErrFlag1
         JC     VVErr         ;   < 砫쭮
         RET
VVErr:   SETB   ErrFlag1      ; 訡
         RET
;
;****** /  .  . ᮢ *********
;室: CharH, CharL - . 
;      CharH1, CharL1 -. 
NAConA:    MOV    A,CharH
           LCALL  PrByte      ; । .  . .
           MOV    A,CharL     ; .  . 
           LCALL  PrByte
           LCALL  XString
           DB     '...',0
           MOV    A,CharH1
           LCALL  PrByte      ; । .  . .
           MOV    A,CharL1     ; .  . 
           LCALL  PrByte
           RET
;
; /  ᮢ   Enter
;室: A -  ᨬ
;
PROMtx:    LCALL  NAConA
           MOV    A,#')'
           LCALL  PutCharDel
PROMtx01:  LCALL  XString
           DB     ' <Enter>',0
           LCALL  GetChar
           RET
;
; /  訡 
; 室: DPTR - 
;       R4   -  
;       P1   -  
; 室:    -  
;
PrnAdrErr: PUSH  DPH
           PUSH  DPL
           LCALL XString
           DB    0DH,0AH,'訡  (:  )',0DH,0AH,0
           POP   DPL
           POP   DPH
           MOV   A,DPH
           LCALL PrByte
           MOV   A,DPL
           LCALL PrByte          ; 뢮 
           MOV   A,#':'
           LCALL PutCharDel
           MOV   A,#' '
           LCALL PutCharDel
           LCALL ReadP1          ; A=  
           LCALL PrByte
           MOV   A,#' '
           LCALL PutCharDel
           MOV   A,R4             ; 
           LCALL PrByte
           PUSH  DPH
           PUSH  DPL
           LCALL XString
           DB    '   <Enter>?',0DH,0AH,0
           POP   DPL
           POP   DPH
           CLR   RI
           LCALL GetChar
           RET
;
;/ 뢮 * १ 512 
;
PrnZv1:    MOV   A,DPL
           JNZ   PrnZv2          ; .    0
           MOV   A,DPH
           ANL   A,#01           ; 뤥 . ࠧ鸞
           JNZ   PrnZv2          ;  xxxx.xxx0
           MOV   A,#'*'
           LCALL PutChar
PrnZv2:    RET


;******  ணࠬ஢ **************
MN1PZU:  DB  0DH,0AH,'A ------------ ⥭ ID'
         DB  0DH,0AH,'R<x y>  ------  --> '
         DB  0DH,0AH,'V<x y>  ------ ࠢ  '
         DB  0DH,0AH,'C<x y>  ------ ஢ઠ  '
         DB  0DH,0AH,'W<x y>  ------  ',0
MN2PZU:  DB  '(<x y> - 砫    )'
MN3PZU:  DB  0DH,0AH,'Esc ---------- 室   ""',0
MNEPZU:  DB  'E ------------ ࠭',0
;
;********** ணࠬ஢ EPROM  FLASH **********
;
EPROM:   CLR     ErrFlag1         ;  䫠 訡
         MOV     DPTR,#MN1PZU
         LCALL   SendStr
         JB      NotFlash,EPROM00 ;  EEPROM, FLASH
         CLR     ProtectON        ;   
         CLR     ProtectOF
         MOV     A,TipPZU
         CJNE    A,#SoftProtect,EPROM06
EPROM06: JC      EPROM07          ;  
         LCALL   XString
         DB     'WP<x y> ------  c ⠭ ',0DH,0AH
         DB     'WN<x y> ------   ⨥ '
         DB      0DH,0AH,0
EPROM07: MOV     DPTR,#MNEPZU
         LCALL   SendStr
EPROM00: MOV     DPTR,#MN2PZU
         LCALL   SendStr
         MOV     A,#'>'
         LCALL   PutCharDel
         LCALL   GetCom            ;    
         CJNE    A,#0DH,EPROMEnd   ; Esc
         SJMP    EPROMAn           ;  
EPROMEnd:RET                       ; 室  
EPROMAn: LCALL   VstAdr            ;  ⠭. ᮢ
         LCALL   CRLF
         MOV     R1,#BufCom
         LCALL   SW02              ; ᪫ ஡
         MOV     A,@R1
         MOV     R5,A              ; ࠭ 
         LCALL   OutDel            ; ᪫ ஡ ᫥ .
         MOV     A,@R1
         JZ      EPROM01           ;    ᨬ
         JB      NotFlash,EPROM08 ;  EEPROM, FLASH
         MOV     A,TipPZU
         CJNE    A,#SoftProtect,EPROM09
EPROM09: JC      EPROM08          ;  
         CJNE    R5,#'W',EPROM08  ;  
         CJNE    @R1,#'P',EPROM0A ;  P
         SETB    ProtectON        ;  EEPROM  ⮩
         SJMP    EPROM0B
EPROM0A: CJNE    @R1,#'N',EPROM08
         SETB    ProtectOF
EPROM0B: LCALL   OutDel   ; ᪫ ஡ ᫥ 2- 㪢
         MOV     A,@R1
         JZ      EPROM01           ;    ᮢ
EPROM08: LCALL   VVAdr             ;  ᮢ  
         JB      ErrFlag1,EPROMErr ; 訡 
;  
EPROM01: MOV     A,R5              ; ⠭ 
         CJNE    A,#'A',EPROM10    ;  ⥭ ID
         AJMP    EPROMID
EPROM10: CJNE    A,#'R',EPROM02    ;  ⥭
         SJMP    EPROMRead
EPROM02: CJNE    A,#'V',EPROM03    ;  ࠢ
         LJMP    EPROMVer
EPROM03: CJNE    A,#'C',EPROM04    ;  ஢.  
         LJMP    EPROMClear
EPROM04: CJNE    A,#'W',EPROM05    ;  
         LJMP    EPROMWrite
EPROM05: CJNE    A,#'E',EPROMErr   ;  ࠭
         JB      NotFlash,EPROMErr ;  FLASH
         LJMP    EPROMStir
EPROMErr:MOV     DPTR,#MesErr      ; 訡 
         LCALL   SendStr
EPROMTip:LCALL   PrnPZU            ;  ப  ⨯
         LJMP    EPROM
;
;********** ⥭ EPROM, EEPROM *************
;
;室: CharH, CharL - . 
;      CharH1, CharL1 -. 
;      MASKA14=1 - 㦭 ᪠ A14
;      Vpp5=1    -  ०. ⥭. Vpp=5v, =0 - Vpp=0v
;      MASKA11=1 - 㦭 ᪠ A11
;      MASKA11$MASKA14=1 - 㦭 ᪠ A15
;
EPROMRead: LCALL  XString
           DB     ' (',0
           LCALL  NAConA            ;  ᮢ
           LCALL  XString
           DB     ') ---> ',0
           LCALL  PROMtx01
           CJNE   A,#0DH,EPROMErr     ;  Enter
           ACALL RVCHE           ; . ०. ⥭
; R7 - 뢮  P3  饭  55
; R6 - 뢮  P3  饭  
           MOV   DPH,CharH       ; .  . 
           MOV   DPL,CharL       ; .  . 
ChtE02:    MOV   P3,R7           ; .  55
           LCALL SETAE           ; - 
           LCALL ReadP1          ; A=   
           MOV   P3,R6           ; .  
           MOVX  @DPTR,A         ; A --> 
ChtE03:    LCALL DHCMP           ; ࠢ ⥪.  . .
           JZ    ChtEEnd         ; ⥪. . = .
           INC   DPTR            ; ᫥.    
           SJMP  ChtE02
ChtEEnd:   MOV   P3,R7           ; .  55
           MOV   R1,#PortC
           MOV   A,#0A1H    ; 1010.0001 CE=1,0E=0,WE32=1,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL PzuOFF          ; 몫祭 
           LCALL SendOK
           RET                   ; 室  . 
;
;********** / . ०. ⥭ EPROM,EEPROM  ᪨
; . .  - Vpp  ⥭ **************
; 室: (ChkSum) - ᪠ .  
;        饭  55
;        R7 - 뢮  P3  饭  55
;        R6 - 뢮  P3  饭  
RVCHE:   MOV    A,#'.'
         LCALL  PutCharDel      ; 뢮 .
         LCALL  PutCharDel
         LCALL  PutCharDel
RVCHEID: MOV   A,#80H           ; ᪠ A15
         MOV   C,MASKA11
         ANL   C,MASKA14        ; MASKA11$MASKA14=1
         JC    RVCH01
         MOV   A,#40H           ; ᪠ A14
         JB    MASKA14,RVCH01
         MOV   A,#08H           ; ᪠ A11
         JB    MASKA11,RVCH01
         CLR   A
RVCH01:  MOV   ChkSum,A         ; ᪠
         MOV   R7,#BB55+Vc5Vp5  ; BB55, Vcc=5v, Vpp=5v
         JB    Vpp5,RVCH02
         MOV   R7,#BB55+Vc5Vp0  ; BB55, Vcc=5v, Vpp=0v
RVCH02:  MOV   P3,R7            ; .  55, . Vcc,Vpp
         MOV   R1,#RUS
         MOV   A,#PABCOUT
         MOVX  @R1,A            ; PA, PB, PC - 뢮
         MOV   R1,#PortC
         ACALL EERele           ; . ५
         MOVX  @R1,A            ; . ५
         MOV   BlkN,A           ; ࠭
         LCALL ZadUART          ; 100ms
         LCALL ZadUART
         MOV   A,#0A1H  ; 1010.0001 CE=1,OE=0,PC5(WE 32pin)=1 Vcc - .
         ORL   A,BlkN           ;  . ५
         MOVX  @R1,A
         MOV   P1,#0FFH         ; ०. ⥭  P1 BE31
         MOV   R1,#PortB
         CLR   A
         MOVX  @R1,A            ; PB=0 (.  )
         MOV   R1,#PortA
         MOV   A,ChkSum
         MOVX  @R1,A            ; PA - .    ᪠
         LCALL Zad10            ; 10ms
         MOV   R6,#OZU+Vc5Vp5   ; OZU, Vcc=5v, Vpp=5v
         JB    Vpp5,RVCH03
         MOV   R6,#OZU+Vc5Vp0   ; OZU, Vcc=5v, Vpp=0v
RVCH03:  MOV   R1,#PortC
         MOV   A,#21H           ; 0010.0001 CE=0,OE=0,WE32=1,Vcc - .
         ORL   A,BlkN           ;  . ५
         MOVX  @R1,A
         RET

; /  . ५  ⥭ EPROM, FLASH
; 室: A - 뢮  PC . ५

EERele:  MOV   A,TipPZU
         JB    NotFlash, EERl01 ; EPROM
         MOVC  A,@A+PC
         RET
; ⠡ ५ FLASH              7854 3210 PC
         DB    08H              ; 0000.1000 W27C512
         DB    0AH              ; 0000.1010 28C16A
         DB    08H              ; 0000.1000 28C17A
         DB    08H              ; 0000.1000 28C64A
         DB    08H              ; 0000.1000 28C64B
         DB    08H              ; 0000.1000 28C256
         DB    08H              ; 0000.1000 29C256
         DB    08H              ; 0000.1000 29C257
         DB    08H              ; 0000.1000 29C512

EERl01:  MOVC  A,@A+PC
         RET
; ⠡ ५ EPROM              7854 3210 PC
         DB    06H              ; 0000.0110 2716
         DB    0AH              ; 0000.1010 2732
         DB    0CH              ; 0000.1100 2764
         DB    0CH              ; 0000.1100 27128
         DB    0CH              ; 0000.1100 27256
         DB    08H              ; 0000.1000 27512
         DB    0CH              ; 0000.1100 27C64
         DB    0CH              ; 0000.1100 27C128
         DB    0CH              ; 0000.1100 27C256
         DB    08H              ; 0000.1000 27C512

;******* / ⠭  EPROM  EEPROM ******
; 室: (ChkSum) - ᪠ .  
;       (DPH) - . 
;       (DPL) - . 
SETAE:   MOV   R1,#PortB
         MOV   A,DPL
         MOVX  @R1,A         ; 뢮 . 
         MOV   R1,#PortA
         JB    NotFlash,SETAE01  ;  EEPROM,FLASH
         MOV   A,TipPZU
         CJNE  A,#Tip28256,SETAE01;  28256
         MOV   A,DPH
         MOV   C,ACC.6       ; A14
         MOV   ACC.7,C       ;   A15
         CLR   ACC.6
         SJMP  SETAE02
SETAE01: MOV   A,DPH
SETAE02: ORL   A,ChkSum
         MOVX  @R1,A;     뢮 . 
         RET
;
;********** / ࠢ ⥪.  . . ********
; 室: (DPH) - .  ⥪. .
;       (DPL) - .  ⥪. .
;       (CharH1) - .  . .
;       (CharL1) - .  . .
; 室: A = 0 (⥪. . =  .)
;
DHCMP:   MOV   A,CharL1
         XRL   A,DPL             ; 0, ᫨ ࠢ
         JNZ   DHCMP01
         MOV   A,CharH1
         XRL   A,DPH             ; 0, ᫨ ࠢ
DHCMP01: RET
;
;********** ⥭ ID EPROM, Flash **************
;室: MASKA14=1 - 㦭 ᪠ A14
;      Vpp5=1    -  ०. ⥭. Vpp=5v, =0 - Vpp=0v
;      MASKA11=1 - 㦭 ᪠ A11
;      MASKA11$MASKA14=1 - 㦭 ᪠ A15
;
EPROMID:   ACALL RVCHEID         ; . ०. ⥭
; R7 - 뢮  P3  饭  55
; R6 - 뢮  P3  饭  
           MOV   DPTR,#0000      ; . 
           MOV   P3,R7           ; .  55
           LCALL SETAE           ; - 
           MOV   R1,#PortC
           MOV   A,#31H   ; 0011.0001 CE=0,OE=0,WE32=1,A9=12v,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL ZadUART          ; 100ms
           LCALL ZadUART
           LCALL XString
           DB    'Manufacture: ',0
           LCALL ReadP1          ; A=   
           LCALL PrByte
           MOV   DPTR,#0001      ; ᫥. 
           LCALL SETAE           ; - 
           LCALL XString
           DB    'H',0DH,0AH,'Device Type: ',0
           LCALL ReadP1          ; A=   
           LCALL PrByte
           LCALL XString
           DB    'H',0DH,0AH,0
           MOV   A,#21H   ; 0010.0001 CE=0,OE=0,WE32=1,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL ZadUART
           MOV   R1,#PortC
           MOV   A,#0A1H    ; 1010.0001 CE=1,0E=0,WE32=1,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL PzuOFF          ; 몫祭 
           LCALL SendOK
           LJMP  EPROMTip        ; 室   ணࠬ஢

;********** ࠢ EPROM, EEPROM *************
;
;室: CharH, CharL - . 
;      CharH1, CharL1 -. 
;      MASKA14=1 - 㦭 ᪠ A14
;      Vpp5=1    -  ०. ⥭. Vpp=5v, =0 - Vpp=0v
;      MASKA11=1 - 㦭 ᪠ A11
;      MASKA11$MASKA14=1 - 㦭 ᪠ A15
;
VEPROMErr: LJMP   EPROMErr
EPROMVer:  LCALL  XString
           DB     'ࠢ  (',0
           LCALL  NAConA            ;  ᮢ
           LCALL  XString
           DB     ')  ',0
           LCALL  PROMtx01
           CJNE   A,#0DH,VEPROMErr     ;  Enter
VerE00:    MOV    R5,#00               ; 稪 ᮢ
           LCALL RVCHE        ; . ०. ⥭   ᪨
; R7 - 뢮  P3  饭  55
; R6 - 뢮  P3  饭  
; R5 - 稪 ᮢ
; R4 - ࠭   
           MOV   DPH,CharH       ; .  . 
           MOV   DPL,CharL       ; .  . 
VerE02:    MOV   P3,R7           ; .  55
           LCALL SETAE           ; - 
           MOV   P3,R6           ; .  
           MOVX  A,@DPTR         ;  --> A
           PUSH  ACC
           LCALL ReadP1          ; A=  
           MOV   B,A
           POP   ACC
           CJNE  A,B,VerE04     ;   ࠢ 
VerE03:    ACALL DHCMP           ; ࠢ ⥪.  . .
           JZ   VerEEnd          ; ⥪. . = .
           INC   DPTR            ; ᫥.    
           SJMP  VerE02
VerE04:    ACALL PrnEVer         ; 뢮  ᮢ ᮢ
           CJNE  A,#0DH,VerEEnd  ; ⬥ 
           SJMP  VerE03
VerEEnd:   MOV   P3,R7           ; .  55
           MOV   R1,#PortC
           MOV   A,#0A1H   ; 1000.0001 CE=1,0E=0,WE32=1,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL PzuOFF          ; 몫祭 
           LCALL SendOK
           LJMP  EPROMTip        ; 室   ணࠬ஢
;
; ****** /  ᮢ     ******
; 室: DPTR - 
;       A    -   
;       P1   -  
;       R5   -  ⠥ 訡
; ᯮ R4
; 室:    -  ᨬ  0DH
;
PrnEVer:   PUSH  ACC
           LCALL ReadP1
           MOV   TmpPrn,A        ; ࠭  
           POP   ACC
PrnEVerM:  MOV   R4,A            ; ࠭   
           CJNE  R5,#00,PrnEVer01;   㦥
           PUSH  DPH             ; ࠭ DPH
           PUSH  DPL             ; ࠭ DPL
           LCALL XString
           DB 0DH,0AH,'ᮢ  (:  )',0DH,0AH,0
           POP   DPL
           POP   DPH
PrnEVer01: MOV   A,DPH
           LCALL PrByte
           MOV   A,DPL
           LCALL PrByte          ; 뢮 
           MOV   A,#':'
           LCALL PutCharDel
           MOV   A,#' '
           LCALL PutCharDel
           MOV   A,TmpPrn           ; 
           LCALL PrByte
           MOV   A,#' '
           LCALL PutCharDel
           MOV   A,R4             ; 
           LCALL PrByte
           MOV   A,R5
           RRC   A
           JNC   PrnEVer04    ;  稪, 뢮 ஡
           LCALL CRLF
           SJMP  PrnEVer03    ;  稪,   ப
PrnEVer04: MOV   A,#' '
           LCALL PutCharDel
           LCALL PutCharDel
           LCALL PutCharDel
PrnEVer03: INC   R5              ; 稪
           MOV   A,#0DH          ;
           CJNE  R5,#10H,PrnEVerEnd ; 뢥  16 ᮢ
           MOV   R5,#00          ;  稪
           PUSH  DPH             ; ࠭ DPH
           PUSH  DPL             ; ࠭ DPL
           LCALL XString
           DB '? <Enter>',0
           POP   DPL
           POP   DPH
           CLR   RI
           LCALL GetChar
PrnEVerEnd:RET
;
;*** ஢ઠ   EPROM, EEPROM ********
;
;室: CharH, CharL - . 
;      CharH1, CharL1 -. 
;      MASKA14=1 - 㦭 ᪠ A14
;      Vpp5=1    -  ०. ⥭. Vpp=5v, =0 - Vpp=0v
;      MASKA11=1 - 㦭 ᪠ A11
;      MASKA11$MASKA14=1 - 㦭 ᪠ A15
;
CEPROMErr: LJMP   EPROMErr
EPROMClear:LCALL  XString
           DB     '஢ઠ   (',0
           LCALL  PROMtx            ;  ᮢ, . ENTER
           CJNE   A,#0DH,CEPROMErr     ;  Enter
ClearE00:  MOV    R5,#00               ; 稪 ᮢ
           MOV    R4,#0FFH             ; . ﭨ
           LCALL RVCHE        ; . ०. ⥭   ᪨
; R7 - 뢮  P3  饭  55
; R6 - 뢮  P3  饭  
; R5 - 稪 ᮢ
; R4 - . ﭨ
           MOV   DPH,CharH       ; .  . 
           MOV   DPL,CharL       ; .  . 
           MOV   P3,R7           ; .  55
ClearE02:  LCALL SETAE           ; - 
           MOV   A,R4            ; . .
           PUSH  ACC
           LCALL ReadP1          ; A=  
           MOV   B,A
           POP   ACC
           CJNE  A,B,ClearE04   ;  
ClearE03:  LCALL DHCMP           ; ࠢ ⥪.  . .
           JZ    ClearEEnd       ; ⥪. . = .
           INC   DPTR            ; ᫥.    
           SJMP  ClearE02
ClearE04:  LCALL PrnEClear       ; 뢮   ᮢ
           CJNE  A,#0DH,ClearEEnd; ⬥ 
           SJMP  ClearE03        ; த
ClearEEnd: MOV   R1,#PortC
           MOV   A,#0A1H         ; 1010.0001 CE=1,0E=0,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL PzuOFF          ; 몫祭 
           LCALL SendOK
           LJMP  EPROMTip        ; 室   ணࠬ஢
;
; ****** /    ᮢ  ******
; 室: DPTR - 
;       P1   -  
;       R4   - . .
;       R5   -  ⠥ 訡
; 室:    -  ᨬ  0DH
;
PrnEClear: CJNE  R5,#00,PrnEClear1;   㦥
           PUSH  DPH             ; ࠭ DPH
           PUSH  DPL             ; ࠭ DPL
           LCALL XString
           DB    0DH,0AH,'   ﭨ ',0
           MOV   A,R4
           LCALL PrByte
           LCALL CRLF
           POP   DPL
           POP   DPH
PrnEClear1:MOV   A,DPH
           LCALL PrByte
           MOV   A,DPL
           LCALL PrByte          ; 뢮 
           MOV   A,#':'
           LCALL PutCharDel
           MOV   A,#' '
           LCALL PutCharDel
           LCALL ReadP1          ; A=  
           LCALL PrByte
           MOV   A,R5
           RRC   A
           JNC   PrnEClear3    ;  稪, 뢮 ஡
           LCALL CRLF
           SJMP  PrnEClear4    ;  稪,   ப
PrnEClear3:MOV   A,#' '
           LCALL PutCharDel
           LCALL PutCharDel
           LCALL PutCharDel
PrnEClear4:INC   R5              ; 稪
           MOV   A,#0DH          ;
           CJNE  R5,#10H,PrnEClearEnd ; 뢥  16 ᮢ
           MOV   R5,#00          ;  稪
           PUSH  DPH             ; ࠭ DPH
           PUSH  DPL             ; ࠭ DPL
           LCALL XString
           DB '? <Enter>',0
           POP   DPL
           POP   DPH
           CLR   RI
           LCALL GetChar
PrnEClearEnd:RET
;
;**********  EPROM, EEPROM *************
;
; / . ०.  EPROM,EEPROM . ᪨ . .
; 室: MASKA14=1  ⥭ A14=1
;       MASKA11=1  ⥭ A11=1
;       MASKA11$MASKA14=1 - 㦭 ᪠ A15
;       Vpp5   =1  ⥭ Vpp=5(6,5)v, =0 - Vpp=0v
;       Vcc6   =1   Vcc=6,5v, =0 - Vcc=5v
; 室: (ChkSum) - ᪠ .  
;        饭  55
;        R7 - 뢮  P3  饭  55  ०. ⥭
;        PC5=1, PC6=0, PC7=0

RVWrE:   MOV   A,#80H           ; ᪠ A15
         MOV   C,MASKA11
         ANL   C,MASKA14        ; MASKA11$MASKA14=1
         JC    RVWr01
         MOV   A,#40H           ; ᪠ A14
         JB    MASKA14,RVWr01
         MOV   A,#08H           ; ᪠ A11
         JB    MASKA11,RVWr01
         CLR   A
RVWr01:  MOV   ChkSum,A         ; ᪠
         MOV   A,#BB55+Vc6Vp6   ; BB55, Vcc=6,5v, Vpp=6,5v
         JB    Vcc6,RVWr02
         MOV   A,#BB55+Vc5Vp5   ; BB55, Vcc=5v, Vpp=5v
RVWr02:  JB    Vpp5,RVWr03      ; Vpp=Vcc
         ORL   A,#08            ; 0000.1000 P3.3=1 Vpp=0
RVWr03:  MOV   P3,A             ; .  55, . Vcc,Vpp
         MOV   R7,A
         MOV   R1,#RUS
         MOV   A,#PABCOUT
         MOVX  @R1,A            ; PA, PB, PC - 뢮
         MOV   R1,#PortC
         ACALL EERele           ; . ५
         MOVX  @R1,A            ; . ५
         MOV   BlkN,A           ; ࠭
         LCALL ZadUART
         LCALL ZadUART          ; 100ms
         MOV   A,#0A1H  ; 1010.0001 CE=1,OE=0,PC5(WE 32pin)=1 Vcc - .
         ORL   A,BlkN           ;  . ५
         MOVX  @R1,A
         MOV   P1,#0FFH         ; ०. ⥭  P1 BE31
         MOV   R1,#PortB
         CLR   A
         MOVX  @R1,A            ; PB=0 (.  )
         MOV   R1,#PortA
         MOV   A,ChkSum
         MOVX  @R1,A            ; PA - .    ᪠
         LCALL ZadUART          ; 50ms
         MOV   R1,#PortC
         MOV   A,#21H   ; 0010.0001 CE=0,OE=0,WE32=1,Vcc - .
         ORL   A,BlkN           ;  . ५
         MOVX  @R1,A
         RET
;
WEPROMErr: LJMP   EPROMErr
EPROMWrite:JB     NotFlash,WrE10      ;  FLASH
           CJNE   A,#SoftProtect,WrE11
WrE11:     JC     WrE10   ;  ,    1 
           MOV    A,HaSave            ; .  
           JZ     WrE12               ; 29C512
           ANL    CharL,#0C0H         ; 1100.0000    64 
           ORL    CharL1,#3FH         ; 0011.1111
           SJMP   WrE10
WrE12:     ANL    CharL,#80H          ; 1000.0000   128 
           ORL    CharL1,#7FH         ; 0111.1111
WrE10:     LCALL  XString
           DB     '  (',0
           LCALL  PROMtx              ;  ᮢ
           CJNE   A,#0DH,WEPROMErr    ;  Enter
           MOV    A,TipPZU            ; ⨯
           LCALL  RSAP                ;  ᬥ饭  ⠡.
           MOV    R5,A                ; ᬥ饭
           LCALL  RVWrE      ; . ०.    ᪨
           LCALL  CRLF
; R7 - 뢮  P3  饭  55  ०. ⥭
; R6 - - ⮪  .
; R5 - ᬥ饭  ⠡. 室  ⨯
; R4 - ࠭   
           MOV   DPH,CharH       ; .  . 
           MOV   DPL,CharL       ; .  . 
           CLR   RI
WrE02:     MOV   P3,R7           ; .  55, ⥭
           LCALL SETAE           ; - 
           MOV   A,R7
           ORL   A,#OZU
           MOV   P3,A            ; .  
           MOVX  A,@DPTR         ;  --> A
           MOV   R4,A            ; ࠭   
           LCALL ReadP1          ; A=  
           XRL   A,R4
           JZ    WrE03           ;  = 
WrE04:     JBC   RI,WrE05        ; ਭ 
           MOV   P3,R7           ; .  55, ⥭
           LCALL ZapByte         ;   ஫ 
           JNC   WrE03           ; C=0, ᯥ譠 
WrE05:     LCALL PrnAdrErr       ; 뢮  ᮢ 
           CJNE  A,#0DH,WrE08    ; ⬥ 
           SJMP  WrE04           ; ७  
;
; 騩 
WrE03:     LCALL DHCMP           ; ࠢ ⥪.  . .
           JZ    WrE09           ; ⥪. . = .
           INC   DPTR            ; ᫥.    
           LCALL PrnZv1          ; 뢮 * १ 512 
           SJMP  WrE02
WrE08:     MOV   P3,#BB55+Vc5Vp5 ; .  55
           MOV   R1,#PortC
           MOV   A,#0A1H         ; 1010.0001 CE=1,WE32=0,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL PzuOFF          ; 몫祭 
           LCALL XString
           DB    ' ࢠ',0DH,0AH,0
           LJMP  EPROMTip        ; 室   ணࠬ஢
WrE09:     LJMP  VerE00          ; ࠢ    室  
;
;********** ࠭ EEPROM *************
;
SEPROMErr: LJMP   EPROMErr
EPROMStir: LCALL  XString
           DB     '࠭ ',0
           MOV    A,TipPZU
           CJNE   A,#TipW27C512,EPROMStFl ;  W27C512
           AJMP   EPRStW27             ; W27C512
EPROMStFl: LCALL  PROMtx01
           CJNE   A,#0DH,SEPROMErr     ;  Enter
           LCALL  RVWrE                ; CE=0, OE=0,  ᪨
           MOV    P3,#BB55+Vc5Vp5      ; OE=1
           MOV    P3,#BB55+Vc5Vp25     ; OE=12v
           NOP
           MOV    A,#01
           MOV    R1,#PortC
           ORL    A,BlkN               ;  . ५
           MOVX   @R1,A                ; WE32=0, Vc-.
           CLR    A
           MOV    R1,#PortA
           MOVX   @R1,A                ; WE=0
           LCALL  Zad10                ; 10ms
           LCALL  Zad10                ; 20ms
           MOV    A,ChkSum             ; ᪠ . 
           MOVX   @R1,A                ; WE=1
           MOV    A,#21H
           MOV    R1,#PortC
           ORL    A,BlkN               ;  . ५
           MOVX   @R1,A                ; WE32=1, Vc-.
           NOP
           MOV    P3,#BB55+Vc5Vp5      ; OE=1
EPROMStEn: LCALL  XString
           DB     0DH,0AH,'஢ઠ   (',0
           LCALL  VstAdr               ;  ⠭. ᮢ
           LCALL  NAConA
           MOV    A,#')'
           LCALL  PutCharDel
           LJMP   ClearE00           ; ஢ઠ  
;
;࠭ W27C512
S1EPROMEr: LJMP   EPROMErr
EPRStW27:  LCALL  XString
           DB     '. ⠭ Vp=14v',0
           LCALL  PROMtx01
           CJNE   A,#0DH,S1EPROMEr     ;  Enter
           MOV   P3,#BB55+Vc5Vp5   ; BB55, Vcc=5v, Vpp=5v
           MOV   R1,#RUS
           MOV   A,#PABCOUT
           MOVX  @R1,A            ; PA, PB, PC - 뢮
           MOV   R1,#PortC
           ACALL EERele           ; . ५
           MOVX  @R1,A            ; . ५
           MOV   BlkN,A           ; ࠭
           LCALL ZadUART
           LCALL ZadUART          ; 100ms
           MOV   A,#081H          ; 1000.0001 CE=1, Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           MOV   P1,#0FFH         ; ०. ⥭  P1 BE31
           MOV   R1,#PortB
           CLR   A
           MOVX  @R1,A            ; PB=0 (.  )
           MOV   R1,#PortA
           MOVX  @R1,A            ; PA=0 (.  )
           MOV   R1,#PortC
           MOV   A,#091H          ; 1001.0001 CE=1,A9=14v,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL ZadUART          ; 50ms
           MOV   P3,#BB55+Vc5Vp25 ; BB55, Vcc=5v, Vpp=14v
           LCALL ZadUART          ; 50ms
           MOV   A,#011H          ; 0001.0001 CE=0,A9=14v,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL ZadUART
           LCALL ZadUART
           LCALL ZadUART          ; 150ms
           MOV   A,#091H          ; 1001.0001 CE=1,A9=14v,Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL ZadUART
           MOV   P3,#BB55+Vc5Vp5  ; BB55, Vcc=5v, Vpp=5v
           MOV   A,#081H          ; 1000.0001 CE=1, Vcc - .
           ORL   A,BlkN           ;  . ५
           MOVX  @R1,A
           LCALL XString
           DB    0DH,0AH,'⠭ Vp=12v',0
           AJMP  EPROMStEn
;
;*********  祥 EPROM  EEPROM ***********
;
; R7 - 뢮  P3  饭  55  ⥭
; R5 - ᬥ饭  ⠡. 室  ⨯
; R4 -   
; R6 - - ⮪ 
; (ChkSum) - ᪠ . 
;
ZapByte:   PUSH   DPH
           PUSH   DPL
           JB     NotFlash,ZB01  ; EPROM
           MOV    DPTR,#TabZBEEP
           SJMP   ZB02           ; EEPROM,FLASH
ZB01:      MOV    DPTR,#TabZBE
ZB02:      MOV    A,R5
           JMP    @A+DPTR        ; 室   祩

; /  - . ९ EPROM
;
RsImpE:    MOV    A,#MaxTry27+1    ;max - . 
           CLR    C
           SUBB   A,R6             ;- 襤 ᮢ
           MOV    B,#3
           MUL    AB
           MOV    R6,A             ;- . ९
           RET
;
; ⠡ 室   EPROM
TabZBE:    LJMP   WRE2716        ;<1> --> 2716
           LJMP   WRE27512       ;<2> --> 2732 (512)
           LJMP   WRE2764        ;<3> --> 2764
           LJMP   WRE2764        ;<4> --> 27128 (64)
           LJMP   WRE27256       ;<5> --> 27256
           LJMP   WRE27512       ;<6> --> 27512
           LJMP   WRE27C64       ;<7> --> 27C64
           LJMP   WRE27C64       ;<8> --> 27C128 (64)
           LJMP   WRE27C256      ;<9> --> 27C256
           LJMP   WRE27C512      ;<A> --> 27C512
;
; ⠡ 室   EEPROM, FLASH
TabZBEEP:  LJMP   WRE27C512      ;<1> --> W27C512
           LJMP   WRE28C16A      ;<2> --> 28C16A
           LJMP   WRE2817A       ;<3> --> 28C17A
           LJMP   WRE2864A       ;<4> --> 28C64A
           LJMP   WRE28C64B      ;<5> --> 28C64B
           LJMP   WRE28C64B      ;<6> --> 28C256 (28C64B)
           LJMP   WRE29C256      ;<7> --> 29C256
           LJMP   WRE29C257      ;<8> --> 29C257
           LJMP   WRE29C512      ;<9> --> 29C512
;
WRE2716:   POP    DPL
           POP    DPH
           MOV    R6,#MaxTry27      ; - ⮪ 
           MOV    R1,#PortC
W2716RPT:  MOV    A,#41H           ;0100.0001 CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc5Vp25 ; Vcc=5v, Vpp=25v
           NOP
           NOP
           MOV    A,#0C1H          ;1100.0001 CE=1, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  Zad01            ;1ms
           MOV    A,#41H           ;CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=0, OE=0
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W2716ZP          ;९
           DJNZ   R6,W2716RPT      ;᫥. 
           SETB   C
           RET                     ;室  訡 
W2716ZP:   ACALL  RsImpE           ; - . ९
           MOV    A,#41H
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=0, OE=1
           MOV    P3,#BB55+Vc5Vp25
           MOV    P1,R4
           MOV    A,#0C1H
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=1, OE=1
W2716IMP:  LCALL  Zad01
           DJNZ   R6,W2716IMP
           MOV    A,#41H
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=0, OE=1
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=0, OE=0
           CLR    C
           RET                     ;ᯥ譠 
;
WRE2764:   POP    DPL
           POP    DPH
           MOV    R6,#MaxTry27      ; - ⮪ 
W2764RPT:  MOV    R1,#PortC
           MOV    A,#41H           ;0100.0001 CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc5Vp25 ; Vcc=5v, Vpp=25v
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           ANL    A,#0BFH          ;1011.1111,  A14=0
           MOVX   @R1,A
           LCALL  Zad01            ;1ms
           MOV    A,DPH
           ORL    A,#40H           ;0100.0000,  A14=1
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    R1,#PortC
           MOV    A,#01            ;CE=0, OE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W2764ZP          ;९
           DJNZ   R6,W2764RPT      ;᫥. 
           SETB   C
           RET                     ;室  訡 
W2764ZP:   LCALL  RsImpE           ; - . ९
           MOV    A,#41H
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=0, OE=1
           MOV    P3,#BB55+Vc5Vp25
           MOV    P1,R4
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           ANL    A,#0BFH          ;1011.1111,  A14=0
           MOVX   @R1,A
W2764IMP:  LCALL  Zad01            ;1ms
           DJNZ   R6,W2764IMP
           MOV    A,DPH
           ORL    A,#40H           ;0100.0000,  A14=1
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    R1,#PortC
           MOV    A,#01            ;CE=0, OE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           CLR    C
           RET                     ;ᯥ譠 
;
WRE27256:  POP    DPL
           POP    DPH
           MOV    R6,#MaxTry27     ; - ⮪ 
           MOV    R1,#PortC
W27256RPT: MOV    A,#0C1H          ;1100.0001 CE=1, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc5Vp25 ; Vcc=5v, Vpp=25v
           MOV    A,#41H           ; 0100.0001 CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  Zad01            ;1ms
           MOV    A,#0C1H          ; CE=1, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01            ;CE=0, OE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W27256ZP         ;९
           DJNZ   R6,W27256RPT     ;᫥. 
           SETB   C
           RET                     ;室  訡 
W27256ZP:  LCALL  RsImpE           ; - . ९
           MOV    A,#0C1H
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A            ;CE=1, OE=1
           MOV    P1,R4
           MOV    P3,#BB55+Vc5Vp25
           MOV    A,#41H           ; 0100.0001 CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
W27256IMP: LCALL  Zad01            ;1ms
           DJNZ   R6,W27256IMP
           MOV    A,#0C1H          ; CE=1, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01            ;CE=0, OE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           CLR    C
           RET                     ;ᯥ譠 
;
WRE27512:  POP    DPL
           POP    DPH
           MOV    R6,#MaxTry27     ; - ⮪ 
           MOV    R1,#PortC
W27512RPT: MOV    A,#81H           ;1000.0001 CE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc5Vp25 ; Vcc=5v, Vpp=25v
           MOV    A,#01H           ; 0000.0001 CE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  Zad01            ;1ms
           MOV    A,#081H          ; CE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01            ;CE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W27512ZP         ;९
           DJNZ   R6,W27512RPT     ;᫥. 
           SETB   C
           RET                     ;室  訡 
W27512ZP:  LCALL  RsImpE           ; - . ९
           MOV    A,#81H           ;1000.0001 CE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc5Vp25 ; Vcc=5v, Vpp=25v
           MOV    A,#01H           ; 0000.0001 CE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
W27512IMP: LCALL  Zad01            ;1ms
           DJNZ   R6,W27512IMP
           MOV    A,#081H          ; CE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01            ;CE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           CLR    C
           RET                     ;ᯥ譠 
;
WRE27C64:  POP    DPL
           POP    DPH
           MOV    R6,#MaxTr27C     ; - ⮪ 
W27C64RPT: MOV    R1,#PortC
           MOV    A,#41H           ;0100.0001 CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc6Vp25 ; Vcc=6,5v, Vpp=25v
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           ANL    A,#0BFH          ;1011.1111,  A14=0
           MOVX   @R1,A
           LCALL  Zad001            ;100mks
           MOV    A,DPH
           ORL    A,#40H           ;0100.0000,  A14=1
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    R1,#PortC
           MOV    A,#01            ;CE=0, OE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W27C64ZP         ;ᠭ
           DJNZ   R6,W27C64RPT     ;᫥. 
           MOV    P3,R7
           SETB   C
           RET                     ;室  訡 
W27C64ZP:  MOV    P3,R7
           CLR    C
           RET                     ;ᯥ譠 
;
WRE27C256: POP    DPL
           POP    DPH
           MOV    R6,#MaxTr27C     ; - ⮪ 
           MOV    R1,#PortC
W27C256RPT:MOV    A,#0C1H          ;1100.0001 CE=1, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    P3,#BB55+Vc6Vp25 ; Vcc=6,5v, Vpp=25v
           MOV    A,#41H           ; 0100.0001 CE=0, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  Zad001           ;100mks
           MOV    A,#0C1H          ; CE=1, OE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    A,#81H           ;CE=1, OE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W27C256ZP        ;ᠭ
           DJNZ   R6,W27C256RPT    ;᫥. 
           MOV    P3,R7
           SETB   C
           RET                     ;室  訡 
W27C256ZP: MOV    P3,R7
           CLR    C
           RET                     ;ᯥ譠 
;
WRE27C512: POP    DPL
           POP    DPH
           MOV    R6,#MaxTr27C     ; - ⮪ 
           MOV    R1,#PortC
W27C512RPT:MOV    A,#81H           ;1000.0001 CE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,R4            ;   
           MOV    A,#BB55+Vc6Vp25  ; BB55, Vcc=6,5v, Vpp=25v
           JB     Vcc6,W27C512R1
           MOV    A,#BB55+Vc5Vp25  ; BB55, Vcc=5v, Vpp=25v
W27C512R1: MOV    P3,A
           MOV    A,#01H           ; 0000.0001 CE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  Zad001           ;100mks
           MOV    A,#081H          ; CE=1
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    P1,#0FFH
           MOV    P3,R7            ;⥭
           MOV    A,#01            ;CE=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W27C512ZP        ;ᠭ
           DJNZ   R6,W27C512RPT    ;᫥. 
           SETB   C
           RET                     ;室  訡 
W27C512ZP: CLR    C
           RET                     ;ᯥ譠 
;
WRE2817A:  POP    DPL
           POP    DPH
           MOV    P3,#BB55+Vc5Vp5  ; OE=1
           MOV    P1,R4            ;   
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           ANL    A,#0BFH          ;1011.1111,  A14=0
           MOVX   @R1,A
           ORL    A,#40H           ;0100.0000,  A14=1
           NOP
W281617:   MOVX   @R1,A
           LCALL  Zad10            ;10ms
           LCALL  Zad10            ; 20ms
           MOV    P1,#0FFH
           MOV    P3,R7            ;OE=0
           LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W2817ZP          ;ᠭ
           SETB   C
           RET                     ;室  訡 
W2817ZP:   CLR    C
           RET                     ;ᯥ譠 
;
WRE2864A:  POP    DPL
           POP    DPH
           MOV    P3,#BB55+Vc5Vp5  ; OE=1
           MOV    P1,R4            ;   
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           ANL    A,#0BFH          ;1011.1111,  A14=0
           MOVX   @R1,A
           ORL    A,#40H           ;0100.0000,  A14=1
           NOP
           MOVX   @R1,A
           LCALL  Zad01            ;1ms
           MOV    P1,#0FFH
           MOV    P3,R7            ;OE=0
           MOV    R6,#20           ; max - .  1ms
W2864RPT:  LCALL  ReadP1           ; A=  
           XRL    A,R4
           JZ     W2817ZP          ;ᠭ
           LCALL  Zad01
           DJNZ   R6,W2864RPT      ;
           SETB   C
           RET                     ;室  訡 
;
WRE28C16A: POP    DPL
           POP    DPH
           MOV    P3,#BB55+Vc5Vp5  ; OE=1
           MOV    P1,R4            ;   
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           ANL    A,#0F7H          ;1111.0111,  A11=0
           MOVX   @R1,A
           MOV    A,DPH
           ORL    A,#08H           ;0000.1000,  A11=1
           SJMP   W281617

;  28C64B  28C256 (࠭ 64 )
WRE28C64B: MOV    C,ProtectON
           ORL    C,ProtectOF
           JNC    W2864NotP
           ACALL  Prot2864
W2864NotP: MOV    R6,#64           ;  ࠭ 
           POP    DPL
           POP    DPH
           ANL    DPL,#0C0H        ; xx00.0000 = . 
           PUSH   DPH
           PUSH   DPL
           MOV    A,DPH            ;.  
           MOV    C,ACC.6          ; A14-->A15
           MOV    ACC.7,C
           MOV    DPH,A
W2864Nxt:  MOV    P3,#OZU+Vc5Vp5   ; OE=1
           MOVX   A,@DPTR
           MOV    P1,A             ;   
           MOV    P3,#BB55+Vc5Vp5
           MOV    R1,#PortB
           MOV    A,DPL            ;.  
           MOVX   @R1,A
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           CLR    ACC.6            ; A14=0
           MOVX   @R1,A
           SETB   ACC.6            ; A14=1
           NOP
           MOVX   @R1,A
           INC    DPTR
           DJNZ   R6,W2864Nxt      ; ᫥ 
W2829End:  LCALL  Zad10            ;10ms
           LCALL  Zad10            ; 20ms
           MOV    P1,#0FFH
           MOV    P3,R7            ;OE=0
           POP    DPL
           POP    DPH
           ORL    DPL,#3FH         ; .   =xx11.1111
           CLR    C
           RET

;  29C256 (࠭ 64 )
WRE29C256: MOV    C,ProtectON
           ORL    C,ProtectOF
           JNC    W29256NotP
           ACALL  Prot29256
W29256NotP:MOV    R6,#64           ;  ࠭ 
           POP    DPL
           POP    DPH
           ANL    DPL,#0C0H        ; xx00.0000 = . 
           PUSH   DPH
           PUSH   DPL
W29256Nxt: MOV    P3,#OZU+Vc5Vp5   ; OE=1
           MOVX   A,@DPTR
           MOV    P1,A             ;   
           MOV    P3,#BB55+Vc5Vp5
           MOV    R1,#PortB
           MOV    A,DPL            ;.  
           MOVX   @R1,A
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           CLR    ACC.7            ; A15=0
           MOVX   @R1,A
           SETB   ACC.7            ; A15=1
           NOP
           MOVX   @R1,A
           INC    DPTR
           DJNZ   R6,W29256Nxt     ; ᫥ 
           SJMP   W2829End

;  29C257 (࠭ 64 )
WRE29C257: MOV    C,ProtectON
           ORL    C,ProtectOF
           JNC    W29257NotP
           ACALL  Prot29512
W29257NotP:MOV    R6,#64           ;  ࠭ 
           POP    DPL
           POP    DPH
           ANL    DPL,#0C0H        ; xx00.0000 = . 
           PUSH   DPH
           PUSH   DPL
W29257Nxt: MOV    P3,#OZU+Vc5Vp5   ; OE=1
           MOVX   A,@DPTR
           MOV    P1,A             ;   
           MOV    P3,#BB55+Vc5Vp5
           MOV    R1,#PortB
           MOV    A,DPL            ;.  
           MOVX   @R1,A
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           MOV    R1,#PortC
           MOV    A,#01H           ; WE(PC5)=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    A,#21H   ; 0010.0001 CE=0,OE=0,WE32=1,Vcc - .
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           INC    DPTR
           DJNZ   R6,W29257Nxt     ; ᫥ 
           SJMP   W2829End

;  29C512 (࠭ 128 )
WRE29C512: MOV    C,ProtectON
           ORL    C,ProtectOF
           JNC    W29512NotP
           ACALL  Prot29512
W29512NotP:MOV    R6,#128           ;  ࠭ 
           POP    DPL
           POP    DPH
           ANL    DPL,#80H          ; x000.0000 = . 
           PUSH   DPH
           PUSH   DPL
W29512Nxt: MOV    P3,#OZU+Vc5Vp5   ; OE=1
           MOVX   A,@DPTR
           MOV    P1,A             ;   
           MOV    P3,#BB55+Vc5Vp5
           MOV    R1,#PortB
           MOV    A,DPL            ;.  
           MOVX   @R1,A
           MOV    R1,#PortA
           MOV    A,DPH            ;.  
           MOV    R1,#PortC
           MOV    A,#01H           ; WE(PC5)=0
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           MOV    A,#21H   ; 0010.0001 CE=0,OE=0,WE32=1,Vcc - .
           ORL    A,BlkN           ;  . ५
           MOVX   @R1,A
           INC    DPTR
           DJNZ   R6,W29512Nxt     ; ᫥ 
           LCALL  Zad10            ;10ms
           LCALL  Zad10            ; 20ms
           MOV    P1,#0FFH
           MOV    P3,R7            ;OE=0
           POP    DPL
           POP    DPH
           ORL    DPL,#7FH         ; .   =x111.1111
           CLR    C
           RET

;************** -  ⨥   ****************
; / ⠭/   29C512
; 室: ProtectON =1 - ⠭ 
;                 =0 -  
Prot29512: MOV    R6,#12
           SJMP   Prot2829

;/ ⠭/   29256
; 室: ProtectON =1 - ⠭ 
;                 =0 -  
Prot29256: MOV    R6,#56            ; ਧ 29C256
           SJMP   Prot2829

;/ ⠭/   28C64B
; 室: ProtectON =1 - ⠭ 
;                 =0 -  
Prot2864:  MOV    R6,#64       ; ਧ 2864
Prot2829:  MOV    P3,#BB55+Vc5Vp5   ; OE=1
           MOV    R0,#PortA
           MOV    R1,#PortB
           MOV    A,#0AAH      ; AA-->5555
           LCALL  Wr286455
           MOV    A,#55H       ; 55-->2AAA
           LCALL  Wr2864AA
           JB     ProtectON,Prot2864N ; - 
; ⨥ 
           MOV    A,#80H       ; 80-->5555
           LCALL  Wr286455
           MOV    A,#0AAH      ; AA-->5555
           LCALL  Wr286455
           MOV    A,#55H       ; 55-->2AAA
           LCALL  Wr2864AA
           MOV    A,#20H       ; 20-->5555
           LCALL  Wr286455
           CLR    ProtectOF
           RET
;- 
Prot2864N: MOV    A,#0A0H      ; A0-->5555
           ACALL  Wr286455
           RET

; /    2AAAH
; 室: A -    R6 - 2 .  ⨯
;       R0- PortA
;       R1- PortB
Wr2864AA:   MOV    P1,A
            MOV    A,#0AAH          ; .  
            MOVX   @R1,A
            MOV    A,#02AH          ; .  
            SJMP   Wr2864All

; /    5555H
; 室: A -   R6 - 2 .  ⨯
;       R0- PortA
;       R1- PortB
Wr286455:   MOV    P1,A
            MOV    A,#55H           ; .  .  
            MOVX   @R1,A
Wr2864All:  CJNE   R6,#64,WrNot28   ;  2864
            MOV    C,ACC.6          ; A14-->A15
            MOV    ACC.7,C
            SETB   ACC.6            ; A14=1
            MOVX   @R0,A
            NOP
            CLR    ACC.6            ; A14=0
            MOVX   @R0,A
            SETB   ACC.6            ; A14=1
            NOP
            MOVX   @R0,A
            RET
WrNot28:    CJNE   R6,#56,WrNot29256;  29256,  29512
            SETB   ACC.7            ; A15=1
            MOVX   @R0,A
            NOP
            CLR    ACC.7            ; A15=0
            MOVX   @R0,A
            SETB   ACC.7            ; A15=1
            NOP
            MOVX   @R0,A
            RET
WrNot29256: MOVX   @R0,A            ; 29512
            MOV    R1,#PortC
            MOV    A,#01H           ; WE(PC5)=0
            ORL    A,BlkN           ;  . ५
            MOVX   @R1,A
            MOV    A,#21H   ; 0010.0001 CE=0,OE=0,WE32=1,Vcc - .
            ORL    A,BlkN           ;  . ५
            MOVX   @R1,A
            MOV    R1,#PortB
            RET

;********* / ⥭  P1 31 ***********
; 室: A=P1
ReadP1:   MOV   A,P1
          CJNE  A,P1,ReadP1    ; . , 
          CJNE  A,P1,ReadP1    ; . , 
          CJNE  A,P1,ReadP1    ; . , 
          CJNE  A,P1,ReadP1    ; . , 
          RET

;****************** ᮪ ᮢ  **********
NClas_1  EQU   3          ; - ᮢ+1
;
TabClas: DB    0DH,0AH
         DB    '롥  :',0DH,0AH
         DB    '<1> --> EPROM',0DH,0AH
         DB    '<2> --> FLASH',0DH,0AH,0

;****************** ᮪ EPROM ******************
TAB1:    DB    '<1> --> 2716    (2  0800H  12,5 - 25v)',0
         DB    '<2> --> 2732    (4  1000H  12,5 - 19v)',0
         DB    '<3> --> 2764    (8  2000H  12,5 - 19v)',0
         DB    '<4> --> 27128   (16 4000H  12,5 - 19v)',0
         DB    '<5> --> 27256   (32 8000H  12,5 - 19v)',0
         DB    '<6> --> 27512   (64 10000H 12,5 - 19v)',0
         DB    '<7> --> 27C64   (8  2000H  12,5v)',0
         DB    '<8> --> 27C128  (16 4000H  12,5v)',0
         DB    '<9> --> 27C256  (32 8000H  12,5v)',0
         DB    '<A> --> 27C512  (64 10000H 12,5v)',0,0FFH
;****************** ᮪ EEPROM, FLASH ****************
         DB    '<1> --> W27C512  (64 10000H  12v)',0
         DB    '<2> --> 28C16A   (2   0800H  12v)',0
         DB    '<3> --> 28C17A   (2   0800H  12v)',0
         DB    '<4> --> 28C64A   (8   2000H  12v)',0
         DB    '<5> --> AT28C64B (8k   2000H  12v 64-Byte Page)',0
         DB    '<6> --> AT28C256 (32k  8000H  12v 64-Byte Page)',0
         DB    '<7> --> AT29C256 (32k  8000H  12v 64-Byte Page)',0
         DB    '<8> --> AT29C257 (32k  8000H  12v 64-Byte Page)',0
         DB    '<9> --> AT29C512 (64k 10000H  12v 128-Byte Page)',0,0FFH
;
;**********  ਡ⮢  ******************
;.  , .  , AtribPZU (2CH)
;HEXPIC      EQU  60H; =1 PIC16,AVR,  =0 MCS,PIC18...
;NumBit      EQU  61H; =1 4bit, =0 8bit
;NotFlash    EQU  62H; =1  FLASH,   EEPROM  AVR
;                      =0    FLASH,  EEPROM  AVR
;IshSost     EQU  63H; =1 - FF, =0 - 0
;0FFH -  
; 67 66 65 64 63 62 61 60 -   祩 2CH
;
; ********** EPROM, EEPROM, FLASH ***********
; EPROM, EEPROM
;MASKA14     EQU  64H; =1  ⥭ A14=1
;MASKA11     EQU  65H; =1  ⥭ A11=1
;    MASKA11 $ MASKA14 =1  ⥭ A15=1
;Vpp5        EQU  66H; =1  ⥭ Vpp=5v, =0 - Vpp=0v
;Vcc6        EQU  67H; =1   Vcc=6,5v, =0 - Vcc=5v
TabDLPZU: DB    08H, 00H, 4CH    ;0100.1100  2716         0800H  8bit
          DB    10H, 00H, 0CH    ;0000.1100  2732         1000H  8bit
          DB    20H, 00H, 5CH    ;0101.1100  2764         2000H  8bit
          DB    40H, 00H, 5CH    ;0101.1100  27128        4000H  8bit
          DB    80H, 00H, 4CH    ;0100.1100  27256        8000H  8bit
          DB    00H, 00H, 0CH    ;0000.1100  27512       10000H  8bit
          DB    20H, 00H, 0DCH   ;1101.1100  27C64        2000H  8bit
          DB    40H, 00H, 0DCH   ;1101.1100  27C128       4000H  8bit
          DB    80H, 00H, 0CCH   ;1100.1100  27C256       8000H  8bit
          DB    00H, 00H, 8CH    ;1000.1100  27C512      10000H  8bit
          DB    0FFH
;
          DB    00H, 00H, 08H   ;0000.1000  W27C512  10000H
          DB    08H, 00H, 28H   ;0010.1000  28C16A   0800H
          DB    08H, 00H, 18H   ;0001.1000  28C17A   0800H
          DB    20H, 00H, 18H   ;0001.1000  28C64A   2000H
          DB    20H, 00H, 18H   ;0001.1000  AT28C64B 2000H
          DB    80H, 00H, 18H   ;0001.1000  AT28C256 8000H
          DB    80H, 00H, 38H   ;0011.1000  AT29C256 8000H
          DB    80H, 00H, 08H   ;0000.1000  AT29C257 8000H
          DB    00H, 00H, 08H   ;0000.1000  AT29C512 10000H
          DB    0FFH

          END
